/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package com.facebook.thrift.annotation.cpp_deprecated;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;
import java.util.Collections;
import java.util.BitSet;
import java.util.Arrays;
import com.facebook.thrift.*;
import com.facebook.thrift.annotations.*;
import com.facebook.thrift.async.*;
import com.facebook.thrift.meta_data.*;
import com.facebook.thrift.server.*;
import com.facebook.thrift.transport.*;
import com.facebook.thrift.protocol.*;

/**
 * Lazily deserialize large field on first access.
 * 
 * ```
 * FooWithLazyField foo;
 * apache::thrift::CompactSerializer::deserialize(serializedData, foo);
 * 
 * // large_field is lazy field, it will be deserialized on first access
 * // The data will be deserialized in method call large_field_ref()
 * LOG(INFO) << foo.large_field_ref()->size();
 * 
 * // Result will be cached, we won't deserialize again
 * LOG(INFO) << foo.large_field_ref()->size();
 * ```
 * 
 * Read more: /doc/fb/languages/cpp/lazy.md
 */
@SuppressWarnings({ "unused", "serial" })
public class Lazy implements TBase, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("Lazy");
  private static final TField REF_FIELD_DESC = new TField("ref", TType.BOOL, (short)1);

  public final Boolean ref;
  public static final int REF = 1;

  public Lazy(
      Boolean ref) {
    this.ref = ref;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Lazy(Lazy other) {
    if (other.isSetRef()) {
      this.ref = TBaseHelper.deepCopy(other.ref);
    } else {
      this.ref = null;
    }
  }

  public Lazy deepCopy() {
    return new Lazy(this);
  }

  public Boolean isRef() {
    return this.ref;
  }

  // Returns true if field ref is set (has been assigned a value) and false otherwise
  public boolean isSetRef() {
    return this.ref != null;
  }

  @Override
  public boolean equals(Object _that) {
    if (_that == null)
      return false;
    if (this == _that)
      return true;
    if (!(_that instanceof Lazy))
      return false;
    Lazy that = (Lazy)_that;

    if (!TBaseHelper.equalsNobinary(this.isSetRef(), that.isSetRef(), this.ref, that.ref)) { return false; }

    return true;
  }

  @Override
  public int hashCode() {
    return Arrays.deepHashCode(new Object[] {ref});
  }

  // This is required to satisfy the TBase interface, but can't be implemented on immutable struture.
  public void read(TProtocol iprot) throws TException {
    throw new TException("unimplemented in android immutable structure");
  }

  public static Lazy deserialize(TProtocol iprot) throws TException {
    Boolean tmp_ref = null;
    TField __field;
    iprot.readStructBegin();
    while (true)
    {
      __field = iprot.readFieldBegin();
      if (__field.type == TType.STOP) {
        break;
      }
      switch (__field.id)
      {
        case REF:
          if (__field.type == TType.BOOL) {
            tmp_ref = iprot.readBool();
          } else {
            TProtocolUtil.skip(iprot, __field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, __field.type);
          break;
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    Lazy _that;
    _that = new Lazy(
      tmp_ref
    );
    _that.validate();
    return _that;
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (this.ref != null) {
      oprot.writeFieldBegin(REF_FIELD_DESC);
      oprot.writeBool(this.ref);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    return toString(1, true);
  }

  @Override
  public String toString(int indent, boolean prettyPrint) {
    return TBaseHelper.toStringHelper(this, indent, prettyPrint);
  }

  public void validate() throws TException {
    // check for required fields
  }

}

