/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package com.facebook.thrift.annotation.cpp_deprecated;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;
import java.util.Collections;
import java.util.BitSet;
import java.util.Arrays;
import com.facebook.thrift.*;
import com.facebook.thrift.annotations.*;
import com.facebook.thrift.async.*;
import com.facebook.thrift.meta_data.*;
import com.facebook.thrift.server.*;
import com.facebook.thrift.transport.*;
import com.facebook.thrift.protocol.*;

/**
 * Lazily deserialize large field on first access.
 * 
 * ```
 * FooWithLazyField foo;
 * apache::thrift::CompactSerializer::deserialize(serializedData, foo);
 * 
 * // large_field is lazy field, it will be deserialized on first access
 * // The data will be deserialized in method call large_field_ref()
 * LOG(INFO) << foo.large_field_ref()->size();
 * 
 * // Result will be cached, we won't deserialize again
 * LOG(INFO) << foo.large_field_ref()->size();
 * ```
 * 
 * Read more: /doc/fb/languages/cpp/lazy.md
 */
@SuppressWarnings({ "unused", "serial" })
public class Lazy implements TBase, java.io.Serializable, Cloneable, Comparable<Lazy> {
  private static final TStruct STRUCT_DESC = new TStruct("Lazy");
  private static final TField REF_FIELD_DESC = new TField("ref", TType.BOOL, (short)1);

  public boolean ref;
  public static final int REF = 1;

  // isset id assignments
  private static final int __REF_ISSET_ID = 0;
  private BitSet __isset_bit_vector = new BitSet(1);

  public static final Map<Integer, FieldMetaData> metaDataMap;

  static {
    Map<Integer, FieldMetaData> tmpMetaDataMap = new HashMap<Integer, FieldMetaData>();
    tmpMetaDataMap.put(REF, new FieldMetaData("ref", TFieldRequirementType.DEFAULT, 
        new FieldValueMetaData(TType.BOOL)));
    metaDataMap = Collections.unmodifiableMap(tmpMetaDataMap);
  }

  static {
    FieldMetaData.addStructMetaDataMap(Lazy.class, metaDataMap);
  }

  public Lazy() {
    this.ref = false;

  }

  public Lazy(
      boolean ref) {
    this();
    this.ref = ref;
    setRefIsSet(true);
  }

  public static class Builder {
    private boolean ref;

    BitSet __optional_isset = new BitSet(1);

    public Builder() {
    }

    public Builder setRef(final boolean ref) {
      this.ref = ref;
      __optional_isset.set(__REF_ISSET_ID, true);
      return this;
    }

    public Lazy build() {
      Lazy result = new Lazy();
      if (__optional_isset.get(__REF_ISSET_ID)) {
        result.setRef(this.ref);
      }
      return result;
    }
  }

  public static Builder builder() {
    return new Builder();
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Lazy(Lazy other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    this.ref = TBaseHelper.deepCopy(other.ref);
  }

  public Lazy deepCopy() {
    return new Lazy(this);
  }

  public boolean isRef() {
    return this.ref;
  }

  public Lazy setRef(boolean ref) {
    this.ref = ref;
    setRefIsSet(true);
    return this;
  }

  public void unsetRef() {
    __isset_bit_vector.clear(__REF_ISSET_ID);
  }

  // Returns true if field ref is set (has been assigned a value) and false otherwise
  public boolean isSetRef() {
    return __isset_bit_vector.get(__REF_ISSET_ID);
  }

  public void setRefIsSet(boolean __value) {
    __isset_bit_vector.set(__REF_ISSET_ID, __value);
  }

  public void setFieldValue(int fieldID, Object __value) {
    switch (fieldID) {
    case REF:
      if (__value == null) {
        unsetRef();
      } else {
        setRef((Boolean)__value);
      }
      break;

    default:
      throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
    }
  }

  public Object getFieldValue(int fieldID) {
    switch (fieldID) {
    case REF:
      return new Boolean(isRef());

    default:
      throw new IllegalArgumentException("Field " + fieldID + " doesn't exist!");
    }
  }

  @Override
  public boolean equals(Object _that) {
    if (_that == null)
      return false;
    if (this == _that)
      return true;
    if (!(_that instanceof Lazy))
      return false;
    Lazy that = (Lazy)_that;

    if (!TBaseHelper.equalsNobinary(this.ref, that.ref)) { return false; }

    return true;
  }

  @Override
  public int hashCode() {
    return Arrays.deepHashCode(new Object[] {ref});
  }

  @Override
  public int compareTo(Lazy other) {
    if (other == null) {
      // See java.lang.Comparable docs
      throw new NullPointerException();
    }

    if (other == this) {
      return 0;
    }
    int lastComparison = 0;

    lastComparison = Boolean.valueOf(isSetRef()).compareTo(other.isSetRef());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(ref, other.ref);
    if (lastComparison != 0) { 
      return lastComparison;
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField __field;
    iprot.readStructBegin(metaDataMap);
    while (true)
    {
      __field = iprot.readFieldBegin();
      if (__field.type == TType.STOP) {
        break;
      }
      switch (__field.id)
      {
        case REF:
          if (__field.type == TType.BOOL) {
            this.ref = iprot.readBool();
            setRefIsSet(true);
          } else {
            TProtocolUtil.skip(iprot, __field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, __field.type);
          break;
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();


    // check for required fields of primitive type, which can't be checked in the validate method
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    oprot.writeFieldBegin(REF_FIELD_DESC);
    oprot.writeBool(this.ref);
    oprot.writeFieldEnd();
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    return toString(1, true);
  }

  @Override
  public String toString(int indent, boolean prettyPrint) {
    String indentStr = prettyPrint ? TBaseHelper.getIndentedString(indent) : "";
    String newLine = prettyPrint ? "\n" : "";
    String space = prettyPrint ? " " : "";
    StringBuilder sb = new StringBuilder("Lazy");
    sb.append(space);
    sb.append("(");
    sb.append(newLine);
    boolean first = true;

    sb.append(indentStr);
    sb.append("ref");
    sb.append(space);
    sb.append(":").append(space);
    sb.append(TBaseHelper.toString(this.isRef(), indent + 1, prettyPrint));
    first = false;
    sb.append(newLine + TBaseHelper.reduceIndent(indentStr));
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
  }

}

