/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package com.facebook.thrift.annotation.hack_deprecated;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;
import java.util.Collections;
import java.util.BitSet;
import java.util.Arrays;
import com.facebook.thrift.*;
import com.facebook.thrift.annotations.*;
import com.facebook.thrift.async.*;
import com.facebook.thrift.meta_data.*;
import com.facebook.thrift.server.*;
import com.facebook.thrift.transport.*;
import com.facebook.thrift.protocol.*;

/**
 * An annotation that applies a Hack wrapper to fields, typedef or structs.
 * For example:
 * 
 *   struct User {
 *     @hack.FieldWrapper{name="MyWrapper"}
 *     1: i64 id;
 *   }
 */
@SuppressWarnings({ "unused", "serial" })
public class Wrapper implements TBase, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("Wrapper");
  private static final TField NAME_FIELD_DESC = new TField("name", TType.STRING, (short)1);
  private static final TField UNDERLYING_NAME_FIELD_DESC = new TField("underlyingName", TType.STRING, (short)2);
  private static final TField EXTRA_NAMESPACE_FIELD_DESC = new TField("extraNamespace", TType.STRING, (short)3);

  /**
   * The name of a Hack wrapper class used to wrap the field
   */
  public final String name;
  /**
   * When applied directly to a typedef or struct, the IDL name of the
   * type will refer to the adapted type in Hack and the underlying thrift struct will be
   * generated in a nested namespace and/or with a different name. By default the type/struct
   * will be generated in a nested 'thrift_adapted_types' namespace with the same name,
   * but both of these can be changed by setting these fields.
   * Empty string enables the nested namespace and uses the IDL name for the struct.
   */
  public final String underlyingName;
  public final String extraNamespace;
  public static final int NAME = 1;
  public static final int UNDERLYINGNAME = 2;
  public static final int EXTRANAMESPACE = 3;

  public Wrapper(
      String name,
      String underlyingName,
      String extraNamespace) {
    this.name = name;
    this.underlyingName = underlyingName;
    this.extraNamespace = extraNamespace;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Wrapper(Wrapper other) {
    if (other.isSetName()) {
      this.name = TBaseHelper.deepCopy(other.name);
    } else {
      this.name = null;
    }
    if (other.isSetUnderlyingName()) {
      this.underlyingName = TBaseHelper.deepCopy(other.underlyingName);
    } else {
      this.underlyingName = null;
    }
    if (other.isSetExtraNamespace()) {
      this.extraNamespace = TBaseHelper.deepCopy(other.extraNamespace);
    } else {
      this.extraNamespace = null;
    }
  }

  public Wrapper deepCopy() {
    return new Wrapper(this);
  }

  /**
   * The name of a Hack wrapper class used to wrap the field
   */
  public String getName() {
    return this.name;
  }

  // Returns true if field name is set (has been assigned a value) and false otherwise
  public boolean isSetName() {
    return this.name != null;
  }

  /**
   * When applied directly to a typedef or struct, the IDL name of the
   * type will refer to the adapted type in Hack and the underlying thrift struct will be
   * generated in a nested namespace and/or with a different name. By default the type/struct
   * will be generated in a nested 'thrift_adapted_types' namespace with the same name,
   * but both of these can be changed by setting these fields.
   * Empty string enables the nested namespace and uses the IDL name for the struct.
   */
  public String getUnderlyingName() {
    return this.underlyingName;
  }

  // Returns true if field underlyingName is set (has been assigned a value) and false otherwise
  public boolean isSetUnderlyingName() {
    return this.underlyingName != null;
  }

  public String getExtraNamespace() {
    return this.extraNamespace;
  }

  // Returns true if field extraNamespace is set (has been assigned a value) and false otherwise
  public boolean isSetExtraNamespace() {
    return this.extraNamespace != null;
  }

  @Override
  public boolean equals(Object _that) {
    if (_that == null)
      return false;
    if (this == _that)
      return true;
    if (!(_that instanceof Wrapper))
      return false;
    Wrapper that = (Wrapper)_that;

    if (!TBaseHelper.equalsNobinary(this.isSetName(), that.isSetName(), this.name, that.name)) { return false; }

    if (!TBaseHelper.equalsNobinary(this.isSetUnderlyingName(), that.isSetUnderlyingName(), this.underlyingName, that.underlyingName)) { return false; }

    if (!TBaseHelper.equalsNobinary(this.isSetExtraNamespace(), that.isSetExtraNamespace(), this.extraNamespace, that.extraNamespace)) { return false; }

    return true;
  }

  @Override
  public int hashCode() {
    return Arrays.deepHashCode(new Object[] {name, underlyingName, extraNamespace});
  }

  // This is required to satisfy the TBase interface, but can't be implemented on immutable struture.
  public void read(TProtocol iprot) throws TException {
    throw new TException("unimplemented in android immutable structure");
  }

  public static Wrapper deserialize(TProtocol iprot) throws TException {
    String tmp_name = null;
    String tmp_underlyingName = null;
    String tmp_extraNamespace = null;
    TField __field;
    iprot.readStructBegin();
    while (true)
    {
      __field = iprot.readFieldBegin();
      if (__field.type == TType.STOP) {
        break;
      }
      switch (__field.id)
      {
        case NAME:
          if (__field.type == TType.STRING) {
            tmp_name = iprot.readString();
          } else {
            TProtocolUtil.skip(iprot, __field.type);
          }
          break;
        case UNDERLYINGNAME:
          if (__field.type == TType.STRING) {
            tmp_underlyingName = iprot.readString();
          } else {
            TProtocolUtil.skip(iprot, __field.type);
          }
          break;
        case EXTRANAMESPACE:
          if (__field.type == TType.STRING) {
            tmp_extraNamespace = iprot.readString();
          } else {
            TProtocolUtil.skip(iprot, __field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, __field.type);
          break;
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    Wrapper _that;
    _that = new Wrapper(
      tmp_name
      ,tmp_underlyingName
      ,tmp_extraNamespace
    );
    _that.validate();
    return _that;
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (this.name != null) {
      oprot.writeFieldBegin(NAME_FIELD_DESC);
      oprot.writeString(this.name);
      oprot.writeFieldEnd();
    }
    if (this.underlyingName != null) {
      oprot.writeFieldBegin(UNDERLYING_NAME_FIELD_DESC);
      oprot.writeString(this.underlyingName);
      oprot.writeFieldEnd();
    }
    if (this.extraNamespace != null) {
      oprot.writeFieldBegin(EXTRA_NAMESPACE_FIELD_DESC);
      oprot.writeString(this.extraNamespace);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    return toString(1, true);
  }

  @Override
  public String toString(int indent, boolean prettyPrint) {
    return TBaseHelper.toStringHelper(this, indent, prettyPrint);
  }

  public void validate() throws TException {
    // check for required fields
  }

}

