/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package com.facebook.thrift.annotation.cpp_deprecated;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;
import java.util.Collections;
import java.util.BitSet;
import java.util.Arrays;
import com.facebook.thrift.*;
import com.facebook.thrift.annotations.*;
import com.facebook.thrift.async.*;
import com.facebook.thrift.meta_data.*;
import com.facebook.thrift.server.*;
import com.facebook.thrift.transport.*;
import com.facebook.thrift.protocol.*;

/**
 * This annotation enables reordering of fields in the generated C++ struct to minimize padding.
 * This is achieved by placing the fields in the order of decreasing alignments. The order of fields with the same alignment is preserved.
 * 
 * ```
 * @cpp.MinimizePadding
 * struct Padded {
 *   1: byte small
 *   2: i64 big
 *   3: i16 medium
 *   4: i32 biggish
 *   5: byte tiny
 * }
 * ```
 * 
 * For example, the C++ fields for the `Padded` Thrift struct above will be generated in the following order:
 * 
 * ```
 * int64_t big;
 * int32_t biggish;
 * int16_t medium;
 * int8_t small;
 * int8_t tiny;
 * ```
 * 
 * which gives the size of 16 bytes compared to 32 bytes if `cpp.MinimizePadding` was not specified.
 */
@SuppressWarnings({ "unused", "serial" })
public class MinimizePadding implements TBase, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("MinimizePadding");


  public MinimizePadding() {
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public MinimizePadding(MinimizePadding other) {
  }

  public MinimizePadding deepCopy() {
    return new MinimizePadding(this);
  }

  @Override
  public boolean equals(Object _that) {
    if (_that == null)
      return false;
    if (this == _that)
      return true;
    if (!(_that instanceof MinimizePadding))
      return false;
    MinimizePadding that = (MinimizePadding)_that;

    return true;
  }

  @Override
  public int hashCode() {
    return Arrays.deepHashCode(new Object[] {});
  }

  // This is required to satisfy the TBase interface, but can't be implemented on immutable struture.
  public void read(TProtocol iprot) throws TException {
    throw new TException("unimplemented in android immutable structure");
  }

  public static MinimizePadding deserialize(TProtocol iprot) throws TException {
    TField __field;
    iprot.readStructBegin();
    while (true)
    {
      __field = iprot.readFieldBegin();
      if (__field.type == TType.STOP) {
        break;
      }
      switch (__field.id)
      {
        default:
          TProtocolUtil.skip(iprot, __field.type);
          break;
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    MinimizePadding _that;
    _that = new MinimizePadding(
    );
    _that.validate();
    return _that;
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    return toString(1, true);
  }

  @Override
  public String toString(int indent, boolean prettyPrint) {
    return TBaseHelper.toStringHelper(this, indent, prettyPrint);
  }

  public void validate() throws TException {
    // check for required fields
  }

}

