/*
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

namespace py3 thrift.benchmark
namespace py thrift.benchmark.enum_1000
namespace cpp2 thrift.benchmark.enum_1000

enum Number {
  ZERO = 0,
  ONE = 1,
  TWO = 2,
  THREE = 3,
  FOUR = 4,
  FIVE = 5,
  SIX = 6,
  SEVEN = 7,
  EIGHT = 8,
  NINE = 9,
  TEN = 10,
  ELEVEN = 11,
  TWELVE = 12,
  THIRTEEN = 13,
  FOURTEEN = 14,
  FIFTEEN = 15,
  SIXTEEN = 16,
  SEVENTEEN = 17,
  EIGHTEEN = 18,
  NINETEEN = 19,
  TWENTY = 20,
  TWENTY_ONE = 21,
  TWENTY_TWO = 22,
  TWENTY_THREE = 23,
  TWENTY_FOUR = 24,
  TWENTY_FIVE = 25,
  TWENTY_SIX = 26,
  TWENTY_SEVEN = 27,
  TWENTY_EIGHT = 28,
  TWENTY_NINE = 29,
  THIRTY = 30,
  THIRTY_ONE = 31,
  THIRTY_TWO = 32,
  THIRTY_THREE = 33,
  THIRTY_FOUR = 34,
  THIRTY_FIVE = 35,
  THIRTY_SIX = 36,
  THIRTY_SEVEN = 37,
  THIRTY_EIGHT = 38,
  THIRTY_NINE = 39,
  FORTY = 40,
  FORTY_ONE = 41,
  FORTY_TWO = 42,
  FORTY_THREE = 43,
  FORTY_FOUR = 44,
  FORTY_FIVE = 45,
  FORTY_SIX = 46,
  FORTY_SEVEN = 47,
  FORTY_EIGHT = 48,
  FORTY_NINE = 49,
  FIFTY = 50,
  FIFTY_ONE = 51,
  FIFTY_TWO = 52,
  FIFTY_THREE = 53,
  FIFTY_FOUR = 54,
  FIFTY_FIVE = 55,
  FIFTY_SIX = 56,
  FIFTY_SEVEN = 57,
  FIFTY_EIGHT = 58,
  FIFTY_NINE = 59,
  SIXTY = 60,
  SIXTY_ONE = 61,
  SIXTY_TWO = 62,
  SIXTY_THREE = 63,
  SIXTY_FOUR = 64,
  SIXTY_FIVE = 65,
  SIXTY_SIX = 66,
  SIXTY_SEVEN = 67,
  SIXTY_EIGHT = 68,
  SIXTY_NINE = 69,
  SEVENTY = 70,
  SEVENTY_ONE = 71,
  SEVENTY_TWO = 72,
  SEVENTY_THREE = 73,
  SEVENTY_FOUR = 74,
  SEVENTY_FIVE = 75,
  SEVENTY_SIX = 76,
  SEVENTY_SEVEN = 77,
  SEVENTY_EIGHT = 78,
  SEVENTY_NINE = 79,
  EIGHTY = 80,
  EIGHTY_ONE = 81,
  EIGHTY_TWO = 82,
  EIGHTY_THREE = 83,
  EIGHTY_FOUR = 84,
  EIGHTY_FIVE = 85,
  EIGHTY_SIX = 86,
  EIGHTY_SEVEN = 87,
  EIGHTY_EIGHT = 88,
  EIGHTY_NINE = 89,
  NINETY = 90,
  NINETY_ONE = 91,
  NINETY_TWO = 92,
  NINETY_THREE = 93,
  NINETY_FOUR = 94,
  NINETY_FIVE = 95,
  NINETY_SIX = 96,
  NINETY_SEVEN = 97,
  NINETY_EIGHT = 98,
  NINETY_NINE = 99,
  ONE_HUNDRED = 100,
  ONE_HUNDRED_AND_ONE = 101,
  ONE_HUNDRED_AND_TWO = 102,
  ONE_HUNDRED_AND_THREE = 103,
  ONE_HUNDRED_AND_FOUR = 104,
  ONE_HUNDRED_AND_FIVE = 105,
  ONE_HUNDRED_AND_SIX = 106,
  ONE_HUNDRED_AND_SEVEN = 107,
  ONE_HUNDRED_AND_EIGHT = 108,
  ONE_HUNDRED_AND_NINE = 109,
  ONE_HUNDRED_AND_TEN = 110,
  ONE_HUNDRED_AND_ELEVEN = 111,
  ONE_HUNDRED_AND_TWELVE = 112,
  ONE_HUNDRED_AND_THIRTEEN = 113,
  ONE_HUNDRED_AND_FOURTEEN = 114,
  ONE_HUNDRED_AND_FIFTEEN = 115,
  ONE_HUNDRED_AND_SIXTEEN = 116,
  ONE_HUNDRED_AND_SEVENTEEN = 117,
  ONE_HUNDRED_AND_EIGHTEEN = 118,
  ONE_HUNDRED_AND_NINETEEN = 119,
  ONE_HUNDRED_AND_TWENTY = 120,
  ONE_HUNDRED_AND_TWENTY_ONE = 121,
  ONE_HUNDRED_AND_TWENTY_TWO = 122,
  ONE_HUNDRED_AND_TWENTY_THREE = 123,
  ONE_HUNDRED_AND_TWENTY_FOUR = 124,
  ONE_HUNDRED_AND_TWENTY_FIVE = 125,
  ONE_HUNDRED_AND_TWENTY_SIX = 126,
  ONE_HUNDRED_AND_TWENTY_SEVEN = 127,
  ONE_HUNDRED_AND_TWENTY_EIGHT = 128,
  ONE_HUNDRED_AND_TWENTY_NINE = 129,
  ONE_HUNDRED_AND_THIRTY = 130,
  ONE_HUNDRED_AND_THIRTY_ONE = 131,
  ONE_HUNDRED_AND_THIRTY_TWO = 132,
  ONE_HUNDRED_AND_THIRTY_THREE = 133,
  ONE_HUNDRED_AND_THIRTY_FOUR = 134,
  ONE_HUNDRED_AND_THIRTY_FIVE = 135,
  ONE_HUNDRED_AND_THIRTY_SIX = 136,
  ONE_HUNDRED_AND_THIRTY_SEVEN = 137,
  ONE_HUNDRED_AND_THIRTY_EIGHT = 138,
  ONE_HUNDRED_AND_THIRTY_NINE = 139,
  ONE_HUNDRED_AND_FORTY = 140,
  ONE_HUNDRED_AND_FORTY_ONE = 141,
  ONE_HUNDRED_AND_FORTY_TWO = 142,
  ONE_HUNDRED_AND_FORTY_THREE = 143,
  ONE_HUNDRED_AND_FORTY_FOUR = 144,
  ONE_HUNDRED_AND_FORTY_FIVE = 145,
  ONE_HUNDRED_AND_FORTY_SIX = 146,
  ONE_HUNDRED_AND_FORTY_SEVEN = 147,
  ONE_HUNDRED_AND_FORTY_EIGHT = 148,
  ONE_HUNDRED_AND_FORTY_NINE = 149,
  ONE_HUNDRED_AND_FIFTY = 150,
  ONE_HUNDRED_AND_FIFTY_ONE = 151,
  ONE_HUNDRED_AND_FIFTY_TWO = 152,
  ONE_HUNDRED_AND_FIFTY_THREE = 153,
  ONE_HUNDRED_AND_FIFTY_FOUR = 154,
  ONE_HUNDRED_AND_FIFTY_FIVE = 155,
  ONE_HUNDRED_AND_FIFTY_SIX = 156,
  ONE_HUNDRED_AND_FIFTY_SEVEN = 157,
  ONE_HUNDRED_AND_FIFTY_EIGHT = 158,
  ONE_HUNDRED_AND_FIFTY_NINE = 159,
  ONE_HUNDRED_AND_SIXTY = 160,
  ONE_HUNDRED_AND_SIXTY_ONE = 161,
  ONE_HUNDRED_AND_SIXTY_TWO = 162,
  ONE_HUNDRED_AND_SIXTY_THREE = 163,
  ONE_HUNDRED_AND_SIXTY_FOUR = 164,
  ONE_HUNDRED_AND_SIXTY_FIVE = 165,
  ONE_HUNDRED_AND_SIXTY_SIX = 166,
  ONE_HUNDRED_AND_SIXTY_SEVEN = 167,
  ONE_HUNDRED_AND_SIXTY_EIGHT = 168,
  ONE_HUNDRED_AND_SIXTY_NINE = 169,
  ONE_HUNDRED_AND_SEVENTY = 170,
  ONE_HUNDRED_AND_SEVENTY_ONE = 171,
  ONE_HUNDRED_AND_SEVENTY_TWO = 172,
  ONE_HUNDRED_AND_SEVENTY_THREE = 173,
  ONE_HUNDRED_AND_SEVENTY_FOUR = 174,
  ONE_HUNDRED_AND_SEVENTY_FIVE = 175,
  ONE_HUNDRED_AND_SEVENTY_SIX = 176,
  ONE_HUNDRED_AND_SEVENTY_SEVEN = 177,
  ONE_HUNDRED_AND_SEVENTY_EIGHT = 178,
  ONE_HUNDRED_AND_SEVENTY_NINE = 179,
  ONE_HUNDRED_AND_EIGHTY = 180,
  ONE_HUNDRED_AND_EIGHTY_ONE = 181,
  ONE_HUNDRED_AND_EIGHTY_TWO = 182,
  ONE_HUNDRED_AND_EIGHTY_THREE = 183,
  ONE_HUNDRED_AND_EIGHTY_FOUR = 184,
  ONE_HUNDRED_AND_EIGHTY_FIVE = 185,
  ONE_HUNDRED_AND_EIGHTY_SIX = 186,
  ONE_HUNDRED_AND_EIGHTY_SEVEN = 187,
  ONE_HUNDRED_AND_EIGHTY_EIGHT = 188,
  ONE_HUNDRED_AND_EIGHTY_NINE = 189,
  ONE_HUNDRED_AND_NINETY = 190,
  ONE_HUNDRED_AND_NINETY_ONE = 191,
  ONE_HUNDRED_AND_NINETY_TWO = 192,
  ONE_HUNDRED_AND_NINETY_THREE = 193,
  ONE_HUNDRED_AND_NINETY_FOUR = 194,
  ONE_HUNDRED_AND_NINETY_FIVE = 195,
  ONE_HUNDRED_AND_NINETY_SIX = 196,
  ONE_HUNDRED_AND_NINETY_SEVEN = 197,
  ONE_HUNDRED_AND_NINETY_EIGHT = 198,
  ONE_HUNDRED_AND_NINETY_NINE = 199,
  TWO_HUNDRED = 200,
  TWO_HUNDRED_AND_ONE = 201,
  TWO_HUNDRED_AND_TWO = 202,
  TWO_HUNDRED_AND_THREE = 203,
  TWO_HUNDRED_AND_FOUR = 204,
  TWO_HUNDRED_AND_FIVE = 205,
  TWO_HUNDRED_AND_SIX = 206,
  TWO_HUNDRED_AND_SEVEN = 207,
  TWO_HUNDRED_AND_EIGHT = 208,
  TWO_HUNDRED_AND_NINE = 209,
  TWO_HUNDRED_AND_TEN = 210,
  TWO_HUNDRED_AND_ELEVEN = 211,
  TWO_HUNDRED_AND_TWELVE = 212,
  TWO_HUNDRED_AND_THIRTEEN = 213,
  TWO_HUNDRED_AND_FOURTEEN = 214,
  TWO_HUNDRED_AND_FIFTEEN = 215,
  TWO_HUNDRED_AND_SIXTEEN = 216,
  TWO_HUNDRED_AND_SEVENTEEN = 217,
  TWO_HUNDRED_AND_EIGHTEEN = 218,
  TWO_HUNDRED_AND_NINETEEN = 219,
  TWO_HUNDRED_AND_TWENTY = 220,
  TWO_HUNDRED_AND_TWENTY_ONE = 221,
  TWO_HUNDRED_AND_TWENTY_TWO = 222,
  TWO_HUNDRED_AND_TWENTY_THREE = 223,
  TWO_HUNDRED_AND_TWENTY_FOUR = 224,
  TWO_HUNDRED_AND_TWENTY_FIVE = 225,
  TWO_HUNDRED_AND_TWENTY_SIX = 226,
  TWO_HUNDRED_AND_TWENTY_SEVEN = 227,
  TWO_HUNDRED_AND_TWENTY_EIGHT = 228,
  TWO_HUNDRED_AND_TWENTY_NINE = 229,
  TWO_HUNDRED_AND_THIRTY = 230,
  TWO_HUNDRED_AND_THIRTY_ONE = 231,
  TWO_HUNDRED_AND_THIRTY_TWO = 232,
  TWO_HUNDRED_AND_THIRTY_THREE = 233,
  TWO_HUNDRED_AND_THIRTY_FOUR = 234,
  TWO_HUNDRED_AND_THIRTY_FIVE = 235,
  TWO_HUNDRED_AND_THIRTY_SIX = 236,
  TWO_HUNDRED_AND_THIRTY_SEVEN = 237,
  TWO_HUNDRED_AND_THIRTY_EIGHT = 238,
  TWO_HUNDRED_AND_THIRTY_NINE = 239,
  TWO_HUNDRED_AND_FORTY = 240,
  TWO_HUNDRED_AND_FORTY_ONE = 241,
  TWO_HUNDRED_AND_FORTY_TWO = 242,
  TWO_HUNDRED_AND_FORTY_THREE = 243,
  TWO_HUNDRED_AND_FORTY_FOUR = 244,
  TWO_HUNDRED_AND_FORTY_FIVE = 245,
  TWO_HUNDRED_AND_FORTY_SIX = 246,
  TWO_HUNDRED_AND_FORTY_SEVEN = 247,
  TWO_HUNDRED_AND_FORTY_EIGHT = 248,
  TWO_HUNDRED_AND_FORTY_NINE = 249,
  TWO_HUNDRED_AND_FIFTY = 250,
  TWO_HUNDRED_AND_FIFTY_ONE = 251,
  TWO_HUNDRED_AND_FIFTY_TWO = 252,
  TWO_HUNDRED_AND_FIFTY_THREE = 253,
  TWO_HUNDRED_AND_FIFTY_FOUR = 254,
  TWO_HUNDRED_AND_FIFTY_FIVE = 255,
  TWO_HUNDRED_AND_FIFTY_SIX = 256,
  TWO_HUNDRED_AND_FIFTY_SEVEN = 257,
  TWO_HUNDRED_AND_FIFTY_EIGHT = 258,
  TWO_HUNDRED_AND_FIFTY_NINE = 259,
  TWO_HUNDRED_AND_SIXTY = 260,
  TWO_HUNDRED_AND_SIXTY_ONE = 261,
  TWO_HUNDRED_AND_SIXTY_TWO = 262,
  TWO_HUNDRED_AND_SIXTY_THREE = 263,
  TWO_HUNDRED_AND_SIXTY_FOUR = 264,
  TWO_HUNDRED_AND_SIXTY_FIVE = 265,
  TWO_HUNDRED_AND_SIXTY_SIX = 266,
  TWO_HUNDRED_AND_SIXTY_SEVEN = 267,
  TWO_HUNDRED_AND_SIXTY_EIGHT = 268,
  TWO_HUNDRED_AND_SIXTY_NINE = 269,
  TWO_HUNDRED_AND_SEVENTY = 270,
  TWO_HUNDRED_AND_SEVENTY_ONE = 271,
  TWO_HUNDRED_AND_SEVENTY_TWO = 272,
  TWO_HUNDRED_AND_SEVENTY_THREE = 273,
  TWO_HUNDRED_AND_SEVENTY_FOUR = 274,
  TWO_HUNDRED_AND_SEVENTY_FIVE = 275,
  TWO_HUNDRED_AND_SEVENTY_SIX = 276,
  TWO_HUNDRED_AND_SEVENTY_SEVEN = 277,
  TWO_HUNDRED_AND_SEVENTY_EIGHT = 278,
  TWO_HUNDRED_AND_SEVENTY_NINE = 279,
  TWO_HUNDRED_AND_EIGHTY = 280,
  TWO_HUNDRED_AND_EIGHTY_ONE = 281,
  TWO_HUNDRED_AND_EIGHTY_TWO = 282,
  TWO_HUNDRED_AND_EIGHTY_THREE = 283,
  TWO_HUNDRED_AND_EIGHTY_FOUR = 284,
  TWO_HUNDRED_AND_EIGHTY_FIVE = 285,
  TWO_HUNDRED_AND_EIGHTY_SIX = 286,
  TWO_HUNDRED_AND_EIGHTY_SEVEN = 287,
  TWO_HUNDRED_AND_EIGHTY_EIGHT = 288,
  TWO_HUNDRED_AND_EIGHTY_NINE = 289,
  TWO_HUNDRED_AND_NINETY = 290,
  TWO_HUNDRED_AND_NINETY_ONE = 291,
  TWO_HUNDRED_AND_NINETY_TWO = 292,
  TWO_HUNDRED_AND_NINETY_THREE = 293,
  TWO_HUNDRED_AND_NINETY_FOUR = 294,
  TWO_HUNDRED_AND_NINETY_FIVE = 295,
  TWO_HUNDRED_AND_NINETY_SIX = 296,
  TWO_HUNDRED_AND_NINETY_SEVEN = 297,
  TWO_HUNDRED_AND_NINETY_EIGHT = 298,
  TWO_HUNDRED_AND_NINETY_NINE = 299,
  THREE_HUNDRED = 300,
  THREE_HUNDRED_AND_ONE = 301,
  THREE_HUNDRED_AND_TWO = 302,
  THREE_HUNDRED_AND_THREE = 303,
  THREE_HUNDRED_AND_FOUR = 304,
  THREE_HUNDRED_AND_FIVE = 305,
  THREE_HUNDRED_AND_SIX = 306,
  THREE_HUNDRED_AND_SEVEN = 307,
  THREE_HUNDRED_AND_EIGHT = 308,
  THREE_HUNDRED_AND_NINE = 309,
  THREE_HUNDRED_AND_TEN = 310,
  THREE_HUNDRED_AND_ELEVEN = 311,
  THREE_HUNDRED_AND_TWELVE = 312,
  THREE_HUNDRED_AND_THIRTEEN = 313,
  THREE_HUNDRED_AND_FOURTEEN = 314,
  THREE_HUNDRED_AND_FIFTEEN = 315,
  THREE_HUNDRED_AND_SIXTEEN = 316,
  THREE_HUNDRED_AND_SEVENTEEN = 317,
  THREE_HUNDRED_AND_EIGHTEEN = 318,
  THREE_HUNDRED_AND_NINETEEN = 319,
  THREE_HUNDRED_AND_TWENTY = 320,
  THREE_HUNDRED_AND_TWENTY_ONE = 321,
  THREE_HUNDRED_AND_TWENTY_TWO = 322,
  THREE_HUNDRED_AND_TWENTY_THREE = 323,
  THREE_HUNDRED_AND_TWENTY_FOUR = 324,
  THREE_HUNDRED_AND_TWENTY_FIVE = 325,
  THREE_HUNDRED_AND_TWENTY_SIX = 326,
  THREE_HUNDRED_AND_TWENTY_SEVEN = 327,
  THREE_HUNDRED_AND_TWENTY_EIGHT = 328,
  THREE_HUNDRED_AND_TWENTY_NINE = 329,
  THREE_HUNDRED_AND_THIRTY = 330,
  THREE_HUNDRED_AND_THIRTY_ONE = 331,
  THREE_HUNDRED_AND_THIRTY_TWO = 332,
  THREE_HUNDRED_AND_THIRTY_THREE = 333,
  THREE_HUNDRED_AND_THIRTY_FOUR = 334,
  THREE_HUNDRED_AND_THIRTY_FIVE = 335,
  THREE_HUNDRED_AND_THIRTY_SIX = 336,
  THREE_HUNDRED_AND_THIRTY_SEVEN = 337,
  THREE_HUNDRED_AND_THIRTY_EIGHT = 338,
  THREE_HUNDRED_AND_THIRTY_NINE = 339,
  THREE_HUNDRED_AND_FORTY = 340,
  THREE_HUNDRED_AND_FORTY_ONE = 341,
  THREE_HUNDRED_AND_FORTY_TWO = 342,
  THREE_HUNDRED_AND_FORTY_THREE = 343,
  THREE_HUNDRED_AND_FORTY_FOUR = 344,
  THREE_HUNDRED_AND_FORTY_FIVE = 345,
  THREE_HUNDRED_AND_FORTY_SIX = 346,
  THREE_HUNDRED_AND_FORTY_SEVEN = 347,
  THREE_HUNDRED_AND_FORTY_EIGHT = 348,
  THREE_HUNDRED_AND_FORTY_NINE = 349,
  THREE_HUNDRED_AND_FIFTY = 350,
  THREE_HUNDRED_AND_FIFTY_ONE = 351,
  THREE_HUNDRED_AND_FIFTY_TWO = 352,
  THREE_HUNDRED_AND_FIFTY_THREE = 353,
  THREE_HUNDRED_AND_FIFTY_FOUR = 354,
  THREE_HUNDRED_AND_FIFTY_FIVE = 355,
  THREE_HUNDRED_AND_FIFTY_SIX = 356,
  THREE_HUNDRED_AND_FIFTY_SEVEN = 357,
  THREE_HUNDRED_AND_FIFTY_EIGHT = 358,
  THREE_HUNDRED_AND_FIFTY_NINE = 359,
  THREE_HUNDRED_AND_SIXTY = 360,
  THREE_HUNDRED_AND_SIXTY_ONE = 361,
  THREE_HUNDRED_AND_SIXTY_TWO = 362,
  THREE_HUNDRED_AND_SIXTY_THREE = 363,
  THREE_HUNDRED_AND_SIXTY_FOUR = 364,
  THREE_HUNDRED_AND_SIXTY_FIVE = 365,
  THREE_HUNDRED_AND_SIXTY_SIX = 366,
  THREE_HUNDRED_AND_SIXTY_SEVEN = 367,
  THREE_HUNDRED_AND_SIXTY_EIGHT = 368,
  THREE_HUNDRED_AND_SIXTY_NINE = 369,
  THREE_HUNDRED_AND_SEVENTY = 370,
  THREE_HUNDRED_AND_SEVENTY_ONE = 371,
  THREE_HUNDRED_AND_SEVENTY_TWO = 372,
  THREE_HUNDRED_AND_SEVENTY_THREE = 373,
  THREE_HUNDRED_AND_SEVENTY_FOUR = 374,
  THREE_HUNDRED_AND_SEVENTY_FIVE = 375,
  THREE_HUNDRED_AND_SEVENTY_SIX = 376,
  THREE_HUNDRED_AND_SEVENTY_SEVEN = 377,
  THREE_HUNDRED_AND_SEVENTY_EIGHT = 378,
  THREE_HUNDRED_AND_SEVENTY_NINE = 379,
  THREE_HUNDRED_AND_EIGHTY = 380,
  THREE_HUNDRED_AND_EIGHTY_ONE = 381,
  THREE_HUNDRED_AND_EIGHTY_TWO = 382,
  THREE_HUNDRED_AND_EIGHTY_THREE = 383,
  THREE_HUNDRED_AND_EIGHTY_FOUR = 384,
  THREE_HUNDRED_AND_EIGHTY_FIVE = 385,
  THREE_HUNDRED_AND_EIGHTY_SIX = 386,
  THREE_HUNDRED_AND_EIGHTY_SEVEN = 387,
  THREE_HUNDRED_AND_EIGHTY_EIGHT = 388,
  THREE_HUNDRED_AND_EIGHTY_NINE = 389,
  THREE_HUNDRED_AND_NINETY = 390,
  THREE_HUNDRED_AND_NINETY_ONE = 391,
  THREE_HUNDRED_AND_NINETY_TWO = 392,
  THREE_HUNDRED_AND_NINETY_THREE = 393,
  THREE_HUNDRED_AND_NINETY_FOUR = 394,
  THREE_HUNDRED_AND_NINETY_FIVE = 395,
  THREE_HUNDRED_AND_NINETY_SIX = 396,
  THREE_HUNDRED_AND_NINETY_SEVEN = 397,
  THREE_HUNDRED_AND_NINETY_EIGHT = 398,
  THREE_HUNDRED_AND_NINETY_NINE = 399,
  FOUR_HUNDRED = 400,
  FOUR_HUNDRED_AND_ONE = 401,
  FOUR_HUNDRED_AND_TWO = 402,
  FOUR_HUNDRED_AND_THREE = 403,
  FOUR_HUNDRED_AND_FOUR = 404,
  FOUR_HUNDRED_AND_FIVE = 405,
  FOUR_HUNDRED_AND_SIX = 406,
  FOUR_HUNDRED_AND_SEVEN = 407,
  FOUR_HUNDRED_AND_EIGHT = 408,
  FOUR_HUNDRED_AND_NINE = 409,
  FOUR_HUNDRED_AND_TEN = 410,
  FOUR_HUNDRED_AND_ELEVEN = 411,
  FOUR_HUNDRED_AND_TWELVE = 412,
  FOUR_HUNDRED_AND_THIRTEEN = 413,
  FOUR_HUNDRED_AND_FOURTEEN = 414,
  FOUR_HUNDRED_AND_FIFTEEN = 415,
  FOUR_HUNDRED_AND_SIXTEEN = 416,
  FOUR_HUNDRED_AND_SEVENTEEN = 417,
  FOUR_HUNDRED_AND_EIGHTEEN = 418,
  FOUR_HUNDRED_AND_NINETEEN = 419,
  FOUR_HUNDRED_AND_TWENTY = 420,
  FOUR_HUNDRED_AND_TWENTY_ONE = 421,
  FOUR_HUNDRED_AND_TWENTY_TWO = 422,
  FOUR_HUNDRED_AND_TWENTY_THREE = 423,
  FOUR_HUNDRED_AND_TWENTY_FOUR = 424,
  FOUR_HUNDRED_AND_TWENTY_FIVE = 425,
  FOUR_HUNDRED_AND_TWENTY_SIX = 426,
  FOUR_HUNDRED_AND_TWENTY_SEVEN = 427,
  FOUR_HUNDRED_AND_TWENTY_EIGHT = 428,
  FOUR_HUNDRED_AND_TWENTY_NINE = 429,
  FOUR_HUNDRED_AND_THIRTY = 430,
  FOUR_HUNDRED_AND_THIRTY_ONE = 431,
  FOUR_HUNDRED_AND_THIRTY_TWO = 432,
  FOUR_HUNDRED_AND_THIRTY_THREE = 433,
  FOUR_HUNDRED_AND_THIRTY_FOUR = 434,
  FOUR_HUNDRED_AND_THIRTY_FIVE = 435,
  FOUR_HUNDRED_AND_THIRTY_SIX = 436,
  FOUR_HUNDRED_AND_THIRTY_SEVEN = 437,
  FOUR_HUNDRED_AND_THIRTY_EIGHT = 438,
  FOUR_HUNDRED_AND_THIRTY_NINE = 439,
  FOUR_HUNDRED_AND_FORTY = 440,
  FOUR_HUNDRED_AND_FORTY_ONE = 441,
  FOUR_HUNDRED_AND_FORTY_TWO = 442,
  FOUR_HUNDRED_AND_FORTY_THREE = 443,
  FOUR_HUNDRED_AND_FORTY_FOUR = 444,
  FOUR_HUNDRED_AND_FORTY_FIVE = 445,
  FOUR_HUNDRED_AND_FORTY_SIX = 446,
  FOUR_HUNDRED_AND_FORTY_SEVEN = 447,
  FOUR_HUNDRED_AND_FORTY_EIGHT = 448,
  FOUR_HUNDRED_AND_FORTY_NINE = 449,
  FOUR_HUNDRED_AND_FIFTY = 450,
  FOUR_HUNDRED_AND_FIFTY_ONE = 451,
  FOUR_HUNDRED_AND_FIFTY_TWO = 452,
  FOUR_HUNDRED_AND_FIFTY_THREE = 453,
  FOUR_HUNDRED_AND_FIFTY_FOUR = 454,
  FOUR_HUNDRED_AND_FIFTY_FIVE = 455,
  FOUR_HUNDRED_AND_FIFTY_SIX = 456,
  FOUR_HUNDRED_AND_FIFTY_SEVEN = 457,
  FOUR_HUNDRED_AND_FIFTY_EIGHT = 458,
  FOUR_HUNDRED_AND_FIFTY_NINE = 459,
  FOUR_HUNDRED_AND_SIXTY = 460,
  FOUR_HUNDRED_AND_SIXTY_ONE = 461,
  FOUR_HUNDRED_AND_SIXTY_TWO = 462,
  FOUR_HUNDRED_AND_SIXTY_THREE = 463,
  FOUR_HUNDRED_AND_SIXTY_FOUR = 464,
  FOUR_HUNDRED_AND_SIXTY_FIVE = 465,
  FOUR_HUNDRED_AND_SIXTY_SIX = 466,
  FOUR_HUNDRED_AND_SIXTY_SEVEN = 467,
  FOUR_HUNDRED_AND_SIXTY_EIGHT = 468,
  FOUR_HUNDRED_AND_SIXTY_NINE = 469,
  FOUR_HUNDRED_AND_SEVENTY = 470,
  FOUR_HUNDRED_AND_SEVENTY_ONE = 471,
  FOUR_HUNDRED_AND_SEVENTY_TWO = 472,
  FOUR_HUNDRED_AND_SEVENTY_THREE = 473,
  FOUR_HUNDRED_AND_SEVENTY_FOUR = 474,
  FOUR_HUNDRED_AND_SEVENTY_FIVE = 475,
  FOUR_HUNDRED_AND_SEVENTY_SIX = 476,
  FOUR_HUNDRED_AND_SEVENTY_SEVEN = 477,
  FOUR_HUNDRED_AND_SEVENTY_EIGHT = 478,
  FOUR_HUNDRED_AND_SEVENTY_NINE = 479,
  FOUR_HUNDRED_AND_EIGHTY = 480,
  FOUR_HUNDRED_AND_EIGHTY_ONE = 481,
  FOUR_HUNDRED_AND_EIGHTY_TWO = 482,
  FOUR_HUNDRED_AND_EIGHTY_THREE = 483,
  FOUR_HUNDRED_AND_EIGHTY_FOUR = 484,
  FOUR_HUNDRED_AND_EIGHTY_FIVE = 485,
  FOUR_HUNDRED_AND_EIGHTY_SIX = 486,
  FOUR_HUNDRED_AND_EIGHTY_SEVEN = 487,
  FOUR_HUNDRED_AND_EIGHTY_EIGHT = 488,
  FOUR_HUNDRED_AND_EIGHTY_NINE = 489,
  FOUR_HUNDRED_AND_NINETY = 490,
  FOUR_HUNDRED_AND_NINETY_ONE = 491,
  FOUR_HUNDRED_AND_NINETY_TWO = 492,
  FOUR_HUNDRED_AND_NINETY_THREE = 493,
  FOUR_HUNDRED_AND_NINETY_FOUR = 494,
  FOUR_HUNDRED_AND_NINETY_FIVE = 495,
  FOUR_HUNDRED_AND_NINETY_SIX = 496,
  FOUR_HUNDRED_AND_NINETY_SEVEN = 497,
  FOUR_HUNDRED_AND_NINETY_EIGHT = 498,
  FOUR_HUNDRED_AND_NINETY_NINE = 499,
  FIVE_HUNDRED = 500,
  FIVE_HUNDRED_AND_ONE = 501,
  FIVE_HUNDRED_AND_TWO = 502,
  FIVE_HUNDRED_AND_THREE = 503,
  FIVE_HUNDRED_AND_FOUR = 504,
  FIVE_HUNDRED_AND_FIVE = 505,
  FIVE_HUNDRED_AND_SIX = 506,
  FIVE_HUNDRED_AND_SEVEN = 507,
  FIVE_HUNDRED_AND_EIGHT = 508,
  FIVE_HUNDRED_AND_NINE = 509,
  FIVE_HUNDRED_AND_TEN = 510,
  FIVE_HUNDRED_AND_ELEVEN = 511,
  FIVE_HUNDRED_AND_TWELVE = 512,
  FIVE_HUNDRED_AND_THIRTEEN = 513,
  FIVE_HUNDRED_AND_FOURTEEN = 514,
  FIVE_HUNDRED_AND_FIFTEEN = 515,
  FIVE_HUNDRED_AND_SIXTEEN = 516,
  FIVE_HUNDRED_AND_SEVENTEEN = 517,
  FIVE_HUNDRED_AND_EIGHTEEN = 518,
  FIVE_HUNDRED_AND_NINETEEN = 519,
  FIVE_HUNDRED_AND_TWENTY = 520,
  FIVE_HUNDRED_AND_TWENTY_ONE = 521,
  FIVE_HUNDRED_AND_TWENTY_TWO = 522,
  FIVE_HUNDRED_AND_TWENTY_THREE = 523,
  FIVE_HUNDRED_AND_TWENTY_FOUR = 524,
  FIVE_HUNDRED_AND_TWENTY_FIVE = 525,
  FIVE_HUNDRED_AND_TWENTY_SIX = 526,
  FIVE_HUNDRED_AND_TWENTY_SEVEN = 527,
  FIVE_HUNDRED_AND_TWENTY_EIGHT = 528,
  FIVE_HUNDRED_AND_TWENTY_NINE = 529,
  FIVE_HUNDRED_AND_THIRTY = 530,
  FIVE_HUNDRED_AND_THIRTY_ONE = 531,
  FIVE_HUNDRED_AND_THIRTY_TWO = 532,
  FIVE_HUNDRED_AND_THIRTY_THREE = 533,
  FIVE_HUNDRED_AND_THIRTY_FOUR = 534,
  FIVE_HUNDRED_AND_THIRTY_FIVE = 535,
  FIVE_HUNDRED_AND_THIRTY_SIX = 536,
  FIVE_HUNDRED_AND_THIRTY_SEVEN = 537,
  FIVE_HUNDRED_AND_THIRTY_EIGHT = 538,
  FIVE_HUNDRED_AND_THIRTY_NINE = 539,
  FIVE_HUNDRED_AND_FORTY = 540,
  FIVE_HUNDRED_AND_FORTY_ONE = 541,
  FIVE_HUNDRED_AND_FORTY_TWO = 542,
  FIVE_HUNDRED_AND_FORTY_THREE = 543,
  FIVE_HUNDRED_AND_FORTY_FOUR = 544,
  FIVE_HUNDRED_AND_FORTY_FIVE = 545,
  FIVE_HUNDRED_AND_FORTY_SIX = 546,
  FIVE_HUNDRED_AND_FORTY_SEVEN = 547,
  FIVE_HUNDRED_AND_FORTY_EIGHT = 548,
  FIVE_HUNDRED_AND_FORTY_NINE = 549,
  FIVE_HUNDRED_AND_FIFTY = 550,
  FIVE_HUNDRED_AND_FIFTY_ONE = 551,
  FIVE_HUNDRED_AND_FIFTY_TWO = 552,
  FIVE_HUNDRED_AND_FIFTY_THREE = 553,
  FIVE_HUNDRED_AND_FIFTY_FOUR = 554,
  FIVE_HUNDRED_AND_FIFTY_FIVE = 555,
  FIVE_HUNDRED_AND_FIFTY_SIX = 556,
  FIVE_HUNDRED_AND_FIFTY_SEVEN = 557,
  FIVE_HUNDRED_AND_FIFTY_EIGHT = 558,
  FIVE_HUNDRED_AND_FIFTY_NINE = 559,
  FIVE_HUNDRED_AND_SIXTY = 560,
  FIVE_HUNDRED_AND_SIXTY_ONE = 561,
  FIVE_HUNDRED_AND_SIXTY_TWO = 562,
  FIVE_HUNDRED_AND_SIXTY_THREE = 563,
  FIVE_HUNDRED_AND_SIXTY_FOUR = 564,
  FIVE_HUNDRED_AND_SIXTY_FIVE = 565,
  FIVE_HUNDRED_AND_SIXTY_SIX = 566,
  FIVE_HUNDRED_AND_SIXTY_SEVEN = 567,
  FIVE_HUNDRED_AND_SIXTY_EIGHT = 568,
  FIVE_HUNDRED_AND_SIXTY_NINE = 569,
  FIVE_HUNDRED_AND_SEVENTY = 570,
  FIVE_HUNDRED_AND_SEVENTY_ONE = 571,
  FIVE_HUNDRED_AND_SEVENTY_TWO = 572,
  FIVE_HUNDRED_AND_SEVENTY_THREE = 573,
  FIVE_HUNDRED_AND_SEVENTY_FOUR = 574,
  FIVE_HUNDRED_AND_SEVENTY_FIVE = 575,
  FIVE_HUNDRED_AND_SEVENTY_SIX = 576,
  FIVE_HUNDRED_AND_SEVENTY_SEVEN = 577,
  FIVE_HUNDRED_AND_SEVENTY_EIGHT = 578,
  FIVE_HUNDRED_AND_SEVENTY_NINE = 579,
  FIVE_HUNDRED_AND_EIGHTY = 580,
  FIVE_HUNDRED_AND_EIGHTY_ONE = 581,
  FIVE_HUNDRED_AND_EIGHTY_TWO = 582,
  FIVE_HUNDRED_AND_EIGHTY_THREE = 583,
  FIVE_HUNDRED_AND_EIGHTY_FOUR = 584,
  FIVE_HUNDRED_AND_EIGHTY_FIVE = 585,
  FIVE_HUNDRED_AND_EIGHTY_SIX = 586,
  FIVE_HUNDRED_AND_EIGHTY_SEVEN = 587,
  FIVE_HUNDRED_AND_EIGHTY_EIGHT = 588,
  FIVE_HUNDRED_AND_EIGHTY_NINE = 589,
  FIVE_HUNDRED_AND_NINETY = 590,
  FIVE_HUNDRED_AND_NINETY_ONE = 591,
  FIVE_HUNDRED_AND_NINETY_TWO = 592,
  FIVE_HUNDRED_AND_NINETY_THREE = 593,
  FIVE_HUNDRED_AND_NINETY_FOUR = 594,
  FIVE_HUNDRED_AND_NINETY_FIVE = 595,
  FIVE_HUNDRED_AND_NINETY_SIX = 596,
  FIVE_HUNDRED_AND_NINETY_SEVEN = 597,
  FIVE_HUNDRED_AND_NINETY_EIGHT = 598,
  FIVE_HUNDRED_AND_NINETY_NINE = 599,
  SIX_HUNDRED = 600,
  SIX_HUNDRED_AND_ONE = 601,
  SIX_HUNDRED_AND_TWO = 602,
  SIX_HUNDRED_AND_THREE = 603,
  SIX_HUNDRED_AND_FOUR = 604,
  SIX_HUNDRED_AND_FIVE = 605,
  SIX_HUNDRED_AND_SIX = 606,
  SIX_HUNDRED_AND_SEVEN = 607,
  SIX_HUNDRED_AND_EIGHT = 608,
  SIX_HUNDRED_AND_NINE = 609,
  SIX_HUNDRED_AND_TEN = 610,
  SIX_HUNDRED_AND_ELEVEN = 611,
  SIX_HUNDRED_AND_TWELVE = 612,
  SIX_HUNDRED_AND_THIRTEEN = 613,
  SIX_HUNDRED_AND_FOURTEEN = 614,
  SIX_HUNDRED_AND_FIFTEEN = 615,
  SIX_HUNDRED_AND_SIXTEEN = 616,
  SIX_HUNDRED_AND_SEVENTEEN = 617,
  SIX_HUNDRED_AND_EIGHTEEN = 618,
  SIX_HUNDRED_AND_NINETEEN = 619,
  SIX_HUNDRED_AND_TWENTY = 620,
  SIX_HUNDRED_AND_TWENTY_ONE = 621,
  SIX_HUNDRED_AND_TWENTY_TWO = 622,
  SIX_HUNDRED_AND_TWENTY_THREE = 623,
  SIX_HUNDRED_AND_TWENTY_FOUR = 624,
  SIX_HUNDRED_AND_TWENTY_FIVE = 625,
  SIX_HUNDRED_AND_TWENTY_SIX = 626,
  SIX_HUNDRED_AND_TWENTY_SEVEN = 627,
  SIX_HUNDRED_AND_TWENTY_EIGHT = 628,
  SIX_HUNDRED_AND_TWENTY_NINE = 629,
  SIX_HUNDRED_AND_THIRTY = 630,
  SIX_HUNDRED_AND_THIRTY_ONE = 631,
  SIX_HUNDRED_AND_THIRTY_TWO = 632,
  SIX_HUNDRED_AND_THIRTY_THREE = 633,
  SIX_HUNDRED_AND_THIRTY_FOUR = 634,
  SIX_HUNDRED_AND_THIRTY_FIVE = 635,
  SIX_HUNDRED_AND_THIRTY_SIX = 636,
  SIX_HUNDRED_AND_THIRTY_SEVEN = 637,
  SIX_HUNDRED_AND_THIRTY_EIGHT = 638,
  SIX_HUNDRED_AND_THIRTY_NINE = 639,
  SIX_HUNDRED_AND_FORTY = 640,
  SIX_HUNDRED_AND_FORTY_ONE = 641,
  SIX_HUNDRED_AND_FORTY_TWO = 642,
  SIX_HUNDRED_AND_FORTY_THREE = 643,
  SIX_HUNDRED_AND_FORTY_FOUR = 644,
  SIX_HUNDRED_AND_FORTY_FIVE = 645,
  SIX_HUNDRED_AND_FORTY_SIX = 646,
  SIX_HUNDRED_AND_FORTY_SEVEN = 647,
  SIX_HUNDRED_AND_FORTY_EIGHT = 648,
  SIX_HUNDRED_AND_FORTY_NINE = 649,
  SIX_HUNDRED_AND_FIFTY = 650,
  SIX_HUNDRED_AND_FIFTY_ONE = 651,
  SIX_HUNDRED_AND_FIFTY_TWO = 652,
  SIX_HUNDRED_AND_FIFTY_THREE = 653,
  SIX_HUNDRED_AND_FIFTY_FOUR = 654,
  SIX_HUNDRED_AND_FIFTY_FIVE = 655,
  SIX_HUNDRED_AND_FIFTY_SIX = 656,
  SIX_HUNDRED_AND_FIFTY_SEVEN = 657,
  SIX_HUNDRED_AND_FIFTY_EIGHT = 658,
  SIX_HUNDRED_AND_FIFTY_NINE = 659,
  SIX_HUNDRED_AND_SIXTY = 660,
  SIX_HUNDRED_AND_SIXTY_ONE = 661,
  SIX_HUNDRED_AND_SIXTY_TWO = 662,
  SIX_HUNDRED_AND_SIXTY_THREE = 663,
  SIX_HUNDRED_AND_SIXTY_FOUR = 664,
  SIX_HUNDRED_AND_SIXTY_FIVE = 665,
  SIX_HUNDRED_AND_SIXTY_SIX = 666,
  SIX_HUNDRED_AND_SIXTY_SEVEN = 667,
  SIX_HUNDRED_AND_SIXTY_EIGHT = 668,
  SIX_HUNDRED_AND_SIXTY_NINE = 669,
  SIX_HUNDRED_AND_SEVENTY = 670,
  SIX_HUNDRED_AND_SEVENTY_ONE = 671,
  SIX_HUNDRED_AND_SEVENTY_TWO = 672,
  SIX_HUNDRED_AND_SEVENTY_THREE = 673,
  SIX_HUNDRED_AND_SEVENTY_FOUR = 674,
  SIX_HUNDRED_AND_SEVENTY_FIVE = 675,
  SIX_HUNDRED_AND_SEVENTY_SIX = 676,
  SIX_HUNDRED_AND_SEVENTY_SEVEN = 677,
  SIX_HUNDRED_AND_SEVENTY_EIGHT = 678,
  SIX_HUNDRED_AND_SEVENTY_NINE = 679,
  SIX_HUNDRED_AND_EIGHTY = 680,
  SIX_HUNDRED_AND_EIGHTY_ONE = 681,
  SIX_HUNDRED_AND_EIGHTY_TWO = 682,
  SIX_HUNDRED_AND_EIGHTY_THREE = 683,
  SIX_HUNDRED_AND_EIGHTY_FOUR = 684,
  SIX_HUNDRED_AND_EIGHTY_FIVE = 685,
  SIX_HUNDRED_AND_EIGHTY_SIX = 686,
  SIX_HUNDRED_AND_EIGHTY_SEVEN = 687,
  SIX_HUNDRED_AND_EIGHTY_EIGHT = 688,
  SIX_HUNDRED_AND_EIGHTY_NINE = 689,
  SIX_HUNDRED_AND_NINETY = 690,
  SIX_HUNDRED_AND_NINETY_ONE = 691,
  SIX_HUNDRED_AND_NINETY_TWO = 692,
  SIX_HUNDRED_AND_NINETY_THREE = 693,
  SIX_HUNDRED_AND_NINETY_FOUR = 694,
  SIX_HUNDRED_AND_NINETY_FIVE = 695,
  SIX_HUNDRED_AND_NINETY_SIX = 696,
  SIX_HUNDRED_AND_NINETY_SEVEN = 697,
  SIX_HUNDRED_AND_NINETY_EIGHT = 698,
  SIX_HUNDRED_AND_NINETY_NINE = 699,
  SEVEN_HUNDRED = 700,
  SEVEN_HUNDRED_AND_ONE = 701,
  SEVEN_HUNDRED_AND_TWO = 702,
  SEVEN_HUNDRED_AND_THREE = 703,
  SEVEN_HUNDRED_AND_FOUR = 704,
  SEVEN_HUNDRED_AND_FIVE = 705,
  SEVEN_HUNDRED_AND_SIX = 706,
  SEVEN_HUNDRED_AND_SEVEN = 707,
  SEVEN_HUNDRED_AND_EIGHT = 708,
  SEVEN_HUNDRED_AND_NINE = 709,
  SEVEN_HUNDRED_AND_TEN = 710,
  SEVEN_HUNDRED_AND_ELEVEN = 711,
  SEVEN_HUNDRED_AND_TWELVE = 712,
  SEVEN_HUNDRED_AND_THIRTEEN = 713,
  SEVEN_HUNDRED_AND_FOURTEEN = 714,
  SEVEN_HUNDRED_AND_FIFTEEN = 715,
  SEVEN_HUNDRED_AND_SIXTEEN = 716,
  SEVEN_HUNDRED_AND_SEVENTEEN = 717,
  SEVEN_HUNDRED_AND_EIGHTEEN = 718,
  SEVEN_HUNDRED_AND_NINETEEN = 719,
  SEVEN_HUNDRED_AND_TWENTY = 720,
  SEVEN_HUNDRED_AND_TWENTY_ONE = 721,
  SEVEN_HUNDRED_AND_TWENTY_TWO = 722,
  SEVEN_HUNDRED_AND_TWENTY_THREE = 723,
  SEVEN_HUNDRED_AND_TWENTY_FOUR = 724,
  SEVEN_HUNDRED_AND_TWENTY_FIVE = 725,
  SEVEN_HUNDRED_AND_TWENTY_SIX = 726,
  SEVEN_HUNDRED_AND_TWENTY_SEVEN = 727,
  SEVEN_HUNDRED_AND_TWENTY_EIGHT = 728,
  SEVEN_HUNDRED_AND_TWENTY_NINE = 729,
  SEVEN_HUNDRED_AND_THIRTY = 730,
  SEVEN_HUNDRED_AND_THIRTY_ONE = 731,
  SEVEN_HUNDRED_AND_THIRTY_TWO = 732,
  SEVEN_HUNDRED_AND_THIRTY_THREE = 733,
  SEVEN_HUNDRED_AND_THIRTY_FOUR = 734,
  SEVEN_HUNDRED_AND_THIRTY_FIVE = 735,
  SEVEN_HUNDRED_AND_THIRTY_SIX = 736,
  SEVEN_HUNDRED_AND_THIRTY_SEVEN = 737,
  SEVEN_HUNDRED_AND_THIRTY_EIGHT = 738,
  SEVEN_HUNDRED_AND_THIRTY_NINE = 739,
  SEVEN_HUNDRED_AND_FORTY = 740,
  SEVEN_HUNDRED_AND_FORTY_ONE = 741,
  SEVEN_HUNDRED_AND_FORTY_TWO = 742,
  SEVEN_HUNDRED_AND_FORTY_THREE = 743,
  SEVEN_HUNDRED_AND_FORTY_FOUR = 744,
  SEVEN_HUNDRED_AND_FORTY_FIVE = 745,
  SEVEN_HUNDRED_AND_FORTY_SIX = 746,
  SEVEN_HUNDRED_AND_FORTY_SEVEN = 747,
  SEVEN_HUNDRED_AND_FORTY_EIGHT = 748,
  SEVEN_HUNDRED_AND_FORTY_NINE = 749,
  SEVEN_HUNDRED_AND_FIFTY = 750,
  SEVEN_HUNDRED_AND_FIFTY_ONE = 751,
  SEVEN_HUNDRED_AND_FIFTY_TWO = 752,
  SEVEN_HUNDRED_AND_FIFTY_THREE = 753,
  SEVEN_HUNDRED_AND_FIFTY_FOUR = 754,
  SEVEN_HUNDRED_AND_FIFTY_FIVE = 755,
  SEVEN_HUNDRED_AND_FIFTY_SIX = 756,
  SEVEN_HUNDRED_AND_FIFTY_SEVEN = 757,
  SEVEN_HUNDRED_AND_FIFTY_EIGHT = 758,
  SEVEN_HUNDRED_AND_FIFTY_NINE = 759,
  SEVEN_HUNDRED_AND_SIXTY = 760,
  SEVEN_HUNDRED_AND_SIXTY_ONE = 761,
  SEVEN_HUNDRED_AND_SIXTY_TWO = 762,
  SEVEN_HUNDRED_AND_SIXTY_THREE = 763,
  SEVEN_HUNDRED_AND_SIXTY_FOUR = 764,
  SEVEN_HUNDRED_AND_SIXTY_FIVE = 765,
  SEVEN_HUNDRED_AND_SIXTY_SIX = 766,
  SEVEN_HUNDRED_AND_SIXTY_SEVEN = 767,
  SEVEN_HUNDRED_AND_SIXTY_EIGHT = 768,
  SEVEN_HUNDRED_AND_SIXTY_NINE = 769,
  SEVEN_HUNDRED_AND_SEVENTY = 770,
  SEVEN_HUNDRED_AND_SEVENTY_ONE = 771,
  SEVEN_HUNDRED_AND_SEVENTY_TWO = 772,
  SEVEN_HUNDRED_AND_SEVENTY_THREE = 773,
  SEVEN_HUNDRED_AND_SEVENTY_FOUR = 774,
  SEVEN_HUNDRED_AND_SEVENTY_FIVE = 775,
  SEVEN_HUNDRED_AND_SEVENTY_SIX = 776,
  SEVEN_HUNDRED_AND_SEVENTY_SEVEN = 777,
  SEVEN_HUNDRED_AND_SEVENTY_EIGHT = 778,
  SEVEN_HUNDRED_AND_SEVENTY_NINE = 779,
  SEVEN_HUNDRED_AND_EIGHTY = 780,
  SEVEN_HUNDRED_AND_EIGHTY_ONE = 781,
  SEVEN_HUNDRED_AND_EIGHTY_TWO = 782,
  SEVEN_HUNDRED_AND_EIGHTY_THREE = 783,
  SEVEN_HUNDRED_AND_EIGHTY_FOUR = 784,
  SEVEN_HUNDRED_AND_EIGHTY_FIVE = 785,
  SEVEN_HUNDRED_AND_EIGHTY_SIX = 786,
  SEVEN_HUNDRED_AND_EIGHTY_SEVEN = 787,
  SEVEN_HUNDRED_AND_EIGHTY_EIGHT = 788,
  SEVEN_HUNDRED_AND_EIGHTY_NINE = 789,
  SEVEN_HUNDRED_AND_NINETY = 790,
  SEVEN_HUNDRED_AND_NINETY_ONE = 791,
  SEVEN_HUNDRED_AND_NINETY_TWO = 792,
  SEVEN_HUNDRED_AND_NINETY_THREE = 793,
  SEVEN_HUNDRED_AND_NINETY_FOUR = 794,
  SEVEN_HUNDRED_AND_NINETY_FIVE = 795,
  SEVEN_HUNDRED_AND_NINETY_SIX = 796,
  SEVEN_HUNDRED_AND_NINETY_SEVEN = 797,
  SEVEN_HUNDRED_AND_NINETY_EIGHT = 798,
  SEVEN_HUNDRED_AND_NINETY_NINE = 799,
  EIGHT_HUNDRED = 800,
  EIGHT_HUNDRED_AND_ONE = 801,
  EIGHT_HUNDRED_AND_TWO = 802,
  EIGHT_HUNDRED_AND_THREE = 803,
  EIGHT_HUNDRED_AND_FOUR = 804,
  EIGHT_HUNDRED_AND_FIVE = 805,
  EIGHT_HUNDRED_AND_SIX = 806,
  EIGHT_HUNDRED_AND_SEVEN = 807,
  EIGHT_HUNDRED_AND_EIGHT = 808,
  EIGHT_HUNDRED_AND_NINE = 809,
  EIGHT_HUNDRED_AND_TEN = 810,
  EIGHT_HUNDRED_AND_ELEVEN = 811,
  EIGHT_HUNDRED_AND_TWELVE = 812,
  EIGHT_HUNDRED_AND_THIRTEEN = 813,
  EIGHT_HUNDRED_AND_FOURTEEN = 814,
  EIGHT_HUNDRED_AND_FIFTEEN = 815,
  EIGHT_HUNDRED_AND_SIXTEEN = 816,
  EIGHT_HUNDRED_AND_SEVENTEEN = 817,
  EIGHT_HUNDRED_AND_EIGHTEEN = 818,
  EIGHT_HUNDRED_AND_NINETEEN = 819,
  EIGHT_HUNDRED_AND_TWENTY = 820,
  EIGHT_HUNDRED_AND_TWENTY_ONE = 821,
  EIGHT_HUNDRED_AND_TWENTY_TWO = 822,
  EIGHT_HUNDRED_AND_TWENTY_THREE = 823,
  EIGHT_HUNDRED_AND_TWENTY_FOUR = 824,
  EIGHT_HUNDRED_AND_TWENTY_FIVE = 825,
  EIGHT_HUNDRED_AND_TWENTY_SIX = 826,
  EIGHT_HUNDRED_AND_TWENTY_SEVEN = 827,
  EIGHT_HUNDRED_AND_TWENTY_EIGHT = 828,
  EIGHT_HUNDRED_AND_TWENTY_NINE = 829,
  EIGHT_HUNDRED_AND_THIRTY = 830,
  EIGHT_HUNDRED_AND_THIRTY_ONE = 831,
  EIGHT_HUNDRED_AND_THIRTY_TWO = 832,
  EIGHT_HUNDRED_AND_THIRTY_THREE = 833,
  EIGHT_HUNDRED_AND_THIRTY_FOUR = 834,
  EIGHT_HUNDRED_AND_THIRTY_FIVE = 835,
  EIGHT_HUNDRED_AND_THIRTY_SIX = 836,
  EIGHT_HUNDRED_AND_THIRTY_SEVEN = 837,
  EIGHT_HUNDRED_AND_THIRTY_EIGHT = 838,
  EIGHT_HUNDRED_AND_THIRTY_NINE = 839,
  EIGHT_HUNDRED_AND_FORTY = 840,
  EIGHT_HUNDRED_AND_FORTY_ONE = 841,
  EIGHT_HUNDRED_AND_FORTY_TWO = 842,
  EIGHT_HUNDRED_AND_FORTY_THREE = 843,
  EIGHT_HUNDRED_AND_FORTY_FOUR = 844,
  EIGHT_HUNDRED_AND_FORTY_FIVE = 845,
  EIGHT_HUNDRED_AND_FORTY_SIX = 846,
  EIGHT_HUNDRED_AND_FORTY_SEVEN = 847,
  EIGHT_HUNDRED_AND_FORTY_EIGHT = 848,
  EIGHT_HUNDRED_AND_FORTY_NINE = 849,
  EIGHT_HUNDRED_AND_FIFTY = 850,
  EIGHT_HUNDRED_AND_FIFTY_ONE = 851,
  EIGHT_HUNDRED_AND_FIFTY_TWO = 852,
  EIGHT_HUNDRED_AND_FIFTY_THREE = 853,
  EIGHT_HUNDRED_AND_FIFTY_FOUR = 854,
  EIGHT_HUNDRED_AND_FIFTY_FIVE = 855,
  EIGHT_HUNDRED_AND_FIFTY_SIX = 856,
  EIGHT_HUNDRED_AND_FIFTY_SEVEN = 857,
  EIGHT_HUNDRED_AND_FIFTY_EIGHT = 858,
  EIGHT_HUNDRED_AND_FIFTY_NINE = 859,
  EIGHT_HUNDRED_AND_SIXTY = 860,
  EIGHT_HUNDRED_AND_SIXTY_ONE = 861,
  EIGHT_HUNDRED_AND_SIXTY_TWO = 862,
  EIGHT_HUNDRED_AND_SIXTY_THREE = 863,
  EIGHT_HUNDRED_AND_SIXTY_FOUR = 864,
  EIGHT_HUNDRED_AND_SIXTY_FIVE = 865,
  EIGHT_HUNDRED_AND_SIXTY_SIX = 866,
  EIGHT_HUNDRED_AND_SIXTY_SEVEN = 867,
  EIGHT_HUNDRED_AND_SIXTY_EIGHT = 868,
  EIGHT_HUNDRED_AND_SIXTY_NINE = 869,
  EIGHT_HUNDRED_AND_SEVENTY = 870,
  EIGHT_HUNDRED_AND_SEVENTY_ONE = 871,
  EIGHT_HUNDRED_AND_SEVENTY_TWO = 872,
  EIGHT_HUNDRED_AND_SEVENTY_THREE = 873,
  EIGHT_HUNDRED_AND_SEVENTY_FOUR = 874,
  EIGHT_HUNDRED_AND_SEVENTY_FIVE = 875,
  EIGHT_HUNDRED_AND_SEVENTY_SIX = 876,
  EIGHT_HUNDRED_AND_SEVENTY_SEVEN = 877,
  EIGHT_HUNDRED_AND_SEVENTY_EIGHT = 878,
  EIGHT_HUNDRED_AND_SEVENTY_NINE = 879,
  EIGHT_HUNDRED_AND_EIGHTY = 880,
  EIGHT_HUNDRED_AND_EIGHTY_ONE = 881,
  EIGHT_HUNDRED_AND_EIGHTY_TWO = 882,
  EIGHT_HUNDRED_AND_EIGHTY_THREE = 883,
  EIGHT_HUNDRED_AND_EIGHTY_FOUR = 884,
  EIGHT_HUNDRED_AND_EIGHTY_FIVE = 885,
  EIGHT_HUNDRED_AND_EIGHTY_SIX = 886,
  EIGHT_HUNDRED_AND_EIGHTY_SEVEN = 887,
  EIGHT_HUNDRED_AND_EIGHTY_EIGHT = 888,
  EIGHT_HUNDRED_AND_EIGHTY_NINE = 889,
  EIGHT_HUNDRED_AND_NINETY = 890,
  EIGHT_HUNDRED_AND_NINETY_ONE = 891,
  EIGHT_HUNDRED_AND_NINETY_TWO = 892,
  EIGHT_HUNDRED_AND_NINETY_THREE = 893,
  EIGHT_HUNDRED_AND_NINETY_FOUR = 894,
  EIGHT_HUNDRED_AND_NINETY_FIVE = 895,
  EIGHT_HUNDRED_AND_NINETY_SIX = 896,
  EIGHT_HUNDRED_AND_NINETY_SEVEN = 897,
  EIGHT_HUNDRED_AND_NINETY_EIGHT = 898,
  EIGHT_HUNDRED_AND_NINETY_NINE = 899,
  NINE_HUNDRED = 900,
  NINE_HUNDRED_AND_ONE = 901,
  NINE_HUNDRED_AND_TWO = 902,
  NINE_HUNDRED_AND_THREE = 903,
  NINE_HUNDRED_AND_FOUR = 904,
  NINE_HUNDRED_AND_FIVE = 905,
  NINE_HUNDRED_AND_SIX = 906,
  NINE_HUNDRED_AND_SEVEN = 907,
  NINE_HUNDRED_AND_EIGHT = 908,
  NINE_HUNDRED_AND_NINE = 909,
  NINE_HUNDRED_AND_TEN = 910,
  NINE_HUNDRED_AND_ELEVEN = 911,
  NINE_HUNDRED_AND_TWELVE = 912,
  NINE_HUNDRED_AND_THIRTEEN = 913,
  NINE_HUNDRED_AND_FOURTEEN = 914,
  NINE_HUNDRED_AND_FIFTEEN = 915,
  NINE_HUNDRED_AND_SIXTEEN = 916,
  NINE_HUNDRED_AND_SEVENTEEN = 917,
  NINE_HUNDRED_AND_EIGHTEEN = 918,
  NINE_HUNDRED_AND_NINETEEN = 919,
  NINE_HUNDRED_AND_TWENTY = 920,
  NINE_HUNDRED_AND_TWENTY_ONE = 921,
  NINE_HUNDRED_AND_TWENTY_TWO = 922,
  NINE_HUNDRED_AND_TWENTY_THREE = 923,
  NINE_HUNDRED_AND_TWENTY_FOUR = 924,
  NINE_HUNDRED_AND_TWENTY_FIVE = 925,
  NINE_HUNDRED_AND_TWENTY_SIX = 926,
  NINE_HUNDRED_AND_TWENTY_SEVEN = 927,
  NINE_HUNDRED_AND_TWENTY_EIGHT = 928,
  NINE_HUNDRED_AND_TWENTY_NINE = 929,
  NINE_HUNDRED_AND_THIRTY = 930,
  NINE_HUNDRED_AND_THIRTY_ONE = 931,
  NINE_HUNDRED_AND_THIRTY_TWO = 932,
  NINE_HUNDRED_AND_THIRTY_THREE = 933,
  NINE_HUNDRED_AND_THIRTY_FOUR = 934,
  NINE_HUNDRED_AND_THIRTY_FIVE = 935,
  NINE_HUNDRED_AND_THIRTY_SIX = 936,
  NINE_HUNDRED_AND_THIRTY_SEVEN = 937,
  NINE_HUNDRED_AND_THIRTY_EIGHT = 938,
  NINE_HUNDRED_AND_THIRTY_NINE = 939,
  NINE_HUNDRED_AND_FORTY = 940,
  NINE_HUNDRED_AND_FORTY_ONE = 941,
  NINE_HUNDRED_AND_FORTY_TWO = 942,
  NINE_HUNDRED_AND_FORTY_THREE = 943,
  NINE_HUNDRED_AND_FORTY_FOUR = 944,
  NINE_HUNDRED_AND_FORTY_FIVE = 945,
  NINE_HUNDRED_AND_FORTY_SIX = 946,
  NINE_HUNDRED_AND_FORTY_SEVEN = 947,
  NINE_HUNDRED_AND_FORTY_EIGHT = 948,
  NINE_HUNDRED_AND_FORTY_NINE = 949,
  NINE_HUNDRED_AND_FIFTY = 950,
  NINE_HUNDRED_AND_FIFTY_ONE = 951,
  NINE_HUNDRED_AND_FIFTY_TWO = 952,
  NINE_HUNDRED_AND_FIFTY_THREE = 953,
  NINE_HUNDRED_AND_FIFTY_FOUR = 954,
  NINE_HUNDRED_AND_FIFTY_FIVE = 955,
  NINE_HUNDRED_AND_FIFTY_SIX = 956,
  NINE_HUNDRED_AND_FIFTY_SEVEN = 957,
  NINE_HUNDRED_AND_FIFTY_EIGHT = 958,
  NINE_HUNDRED_AND_FIFTY_NINE = 959,
  NINE_HUNDRED_AND_SIXTY = 960,
  NINE_HUNDRED_AND_SIXTY_ONE = 961,
  NINE_HUNDRED_AND_SIXTY_TWO = 962,
  NINE_HUNDRED_AND_SIXTY_THREE = 963,
  NINE_HUNDRED_AND_SIXTY_FOUR = 964,
  NINE_HUNDRED_AND_SIXTY_FIVE = 965,
  NINE_HUNDRED_AND_SIXTY_SIX = 966,
  NINE_HUNDRED_AND_SIXTY_SEVEN = 967,
  NINE_HUNDRED_AND_SIXTY_EIGHT = 968,
  NINE_HUNDRED_AND_SIXTY_NINE = 969,
  NINE_HUNDRED_AND_SEVENTY = 970,
  NINE_HUNDRED_AND_SEVENTY_ONE = 971,
  NINE_HUNDRED_AND_SEVENTY_TWO = 972,
  NINE_HUNDRED_AND_SEVENTY_THREE = 973,
  NINE_HUNDRED_AND_SEVENTY_FOUR = 974,
  NINE_HUNDRED_AND_SEVENTY_FIVE = 975,
  NINE_HUNDRED_AND_SEVENTY_SIX = 976,
  NINE_HUNDRED_AND_SEVENTY_SEVEN = 977,
  NINE_HUNDRED_AND_SEVENTY_EIGHT = 978,
  NINE_HUNDRED_AND_SEVENTY_NINE = 979,
  NINE_HUNDRED_AND_EIGHTY = 980,
  NINE_HUNDRED_AND_EIGHTY_ONE = 981,
  NINE_HUNDRED_AND_EIGHTY_TWO = 982,
  NINE_HUNDRED_AND_EIGHTY_THREE = 983,
  NINE_HUNDRED_AND_EIGHTY_FOUR = 984,
  NINE_HUNDRED_AND_EIGHTY_FIVE = 985,
  NINE_HUNDRED_AND_EIGHTY_SIX = 986,
  NINE_HUNDRED_AND_EIGHTY_SEVEN = 987,
  NINE_HUNDRED_AND_EIGHTY_EIGHT = 988,
  NINE_HUNDRED_AND_EIGHTY_NINE = 989,
  NINE_HUNDRED_AND_NINETY = 990,
  NINE_HUNDRED_AND_NINETY_ONE = 991,
  NINE_HUNDRED_AND_NINETY_TWO = 992,
  NINE_HUNDRED_AND_NINETY_THREE = 993,
  NINE_HUNDRED_AND_NINETY_FOUR = 994,
  NINE_HUNDRED_AND_NINETY_FIVE = 995,
  NINE_HUNDRED_AND_NINETY_SIX = 996,
  NINE_HUNDRED_AND_NINETY_SEVEN = 997,
  NINE_HUNDRED_AND_NINETY_EIGHT = 998,
  NINE_HUNDRED_AND_NINETY_NINE = 999,
}
