/*
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

include "thrift/annotation/thrift.thrift"

@thrift.Experimental
package "facebook.com/thrift/test"

namespace cpp2 apache.thrift.test

struct struct_8 {
  1: struct_8_internal interal;
}
struct terse_struct_8 {
  @thrift.TerseWrite
  1: terse_struct_8_internal interal;
}
struct struct_16 {
  1: struct_16_internal interal;
}
struct terse_struct_16 {
  @thrift.TerseWrite
  1: terse_struct_16_internal interal;
}
struct struct_32 {
  1: struct_32_internal interal;
}
struct terse_struct_32 {
  @thrift.TerseWrite
  1: terse_struct_32_internal interal;
}

struct struct_64 {
  1: struct_64_internal interal;
}
struct terse_struct_64 {
  @thrift.TerseWrite
  1: terse_struct_64_internal interal;
}

struct struct_128 {
  1: struct_128_internal interal;
}
struct terse_struct_128 {
  @thrift.TerseWrite
  1: terse_struct_128_internal interal;
}

struct struct_256 {
  1: struct_256_internal interal;
}
struct terse_struct_256 {
  @thrift.TerseWrite
  1: terse_struct_256_internal interal;
}

struct struct_512 {
  1: struct_512_internal interal;
}
struct terse_struct_512 {
  @thrift.TerseWrite
  1: terse_struct_512_internal interal;
}

struct struct_8_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
}

@thrift.TerseWrite
struct terse_struct_8_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
}

struct struct_16_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
}

@thrift.TerseWrite
struct terse_struct_16_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
}

struct struct_32_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
  17: i32 field17;
  18: i32 field18;
  19: i32 field19;
  20: i32 field20;
  21: i32 field21;
  22: i32 field22;
  23: i32 field23;
  24: i32 field24;
  25: i32 field25;
  26: i32 field26;
  27: i32 field27;
  28: i32 field28;
  29: i32 field29;
  30: i32 field30;
  31: i32 field31;
  32: i32 field32;
}

@thrift.TerseWrite
struct terse_struct_32_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
  17: i32 field17;
  18: i32 field18;
  19: i32 field19;
  20: i32 field20;
  21: i32 field21;
  22: i32 field22;
  23: i32 field23;
  24: i32 field24;
  25: i32 field25;
  26: i32 field26;
  27: i32 field27;
  28: i32 field28;
  29: i32 field29;
  30: i32 field30;
  31: i32 field31;
  32: i32 field32;
}

struct struct_64_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
  17: i32 field17;
  18: i32 field18;
  19: i32 field19;
  20: i32 field20;
  21: i32 field21;
  22: i32 field22;
  23: i32 field23;
  24: i32 field24;
  25: i32 field25;
  26: i32 field26;
  27: i32 field27;
  28: i32 field28;
  29: i32 field29;
  30: i32 field30;
  31: i32 field31;
  32: i32 field32;
  33: i32 field33;
  34: i32 field34;
  35: i32 field35;
  36: i32 field36;
  37: i32 field37;
  38: i32 field38;
  39: i32 field39;
  40: i32 field40;
  41: i32 field41;
  42: i32 field42;
  43: i32 field43;
  44: i32 field44;
  45: i32 field45;
  46: i32 field46;
  47: i32 field47;
  48: i32 field48;
  49: i32 field49;
  50: i32 field50;
  51: i32 field51;
  52: i32 field52;
  53: i32 field53;
  54: i32 field54;
  55: i32 field55;
  56: i32 field56;
  57: i32 field57;
  58: i32 field58;
  59: i32 field59;
  60: i32 field60;
  61: i32 field61;
  62: i32 field62;
  63: i32 field63;
  64: i32 field64;
}

@thrift.TerseWrite
struct terse_struct_64_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
  17: i32 field17;
  18: i32 field18;
  19: i32 field19;
  20: i32 field20;
  21: i32 field21;
  22: i32 field22;
  23: i32 field23;
  24: i32 field24;
  25: i32 field25;
  26: i32 field26;
  27: i32 field27;
  28: i32 field28;
  29: i32 field29;
  30: i32 field30;
  31: i32 field31;
  32: i32 field32;
  33: i32 field33;
  34: i32 field34;
  35: i32 field35;
  36: i32 field36;
  37: i32 field37;
  38: i32 field38;
  39: i32 field39;
  40: i32 field40;
  41: i32 field41;
  42: i32 field42;
  43: i32 field43;
  44: i32 field44;
  45: i32 field45;
  46: i32 field46;
  47: i32 field47;
  48: i32 field48;
  49: i32 field49;
  50: i32 field50;
  51: i32 field51;
  52: i32 field52;
  53: i32 field53;
  54: i32 field54;
  55: i32 field55;
  56: i32 field56;
  57: i32 field57;
  58: i32 field58;
  59: i32 field59;
  60: i32 field60;
  61: i32 field61;
  62: i32 field62;
  63: i32 field63;
  64: i32 field64;
}

struct struct_128_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
  17: i32 field17;
  18: i32 field18;
  19: i32 field19;
  20: i32 field20;
  21: i32 field21;
  22: i32 field22;
  23: i32 field23;
  24: i32 field24;
  25: i32 field25;
  26: i32 field26;
  27: i32 field27;
  28: i32 field28;
  29: i32 field29;
  30: i32 field30;
  31: i32 field31;
  32: i32 field32;
  33: i32 field33;
  34: i32 field34;
  35: i32 field35;
  36: i32 field36;
  37: i32 field37;
  38: i32 field38;
  39: i32 field39;
  40: i32 field40;
  41: i32 field41;
  42: i32 field42;
  43: i32 field43;
  44: i32 field44;
  45: i32 field45;
  46: i32 field46;
  47: i32 field47;
  48: i32 field48;
  49: i32 field49;
  50: i32 field50;
  51: i32 field51;
  52: i32 field52;
  53: i32 field53;
  54: i32 field54;
  55: i32 field55;
  56: i32 field56;
  57: i32 field57;
  58: i32 field58;
  59: i32 field59;
  60: i32 field60;
  61: i32 field61;
  62: i32 field62;
  63: i32 field63;
  64: i32 field64;
  65: i32 field65;
  66: i32 field66;
  67: i32 field67;
  68: i32 field68;
  69: i32 field69;
  70: i32 field70;
  71: i32 field71;
  72: i32 field72;
  73: i32 field73;
  74: i32 field74;
  75: i32 field75;
  76: i32 field76;
  77: i32 field77;
  78: i32 field78;
  79: i32 field79;
  80: i32 field80;
  81: i32 field81;
  82: i32 field82;
  83: i32 field83;
  84: i32 field84;
  85: i32 field85;
  86: i32 field86;
  87: i32 field87;
  88: i32 field88;
  89: i32 field89;
  90: i32 field90;
  91: i32 field91;
  92: i32 field92;
  93: i32 field93;
  94: i32 field94;
  95: i32 field95;
  96: i32 field96;
  97: i32 field97;
  98: i32 field98;
  99: i32 field99;
  100: i32 field100;
  101: i32 field101;
  102: i32 field102;
  103: i32 field103;
  104: i32 field104;
  105: i32 field105;
  106: i32 field106;
  107: i32 field107;
  108: i32 field108;
  109: i32 field109;
  110: i32 field110;
  111: i32 field111;
  112: i32 field112;
  113: i32 field113;
  114: i32 field114;
  115: i32 field115;
  116: i32 field116;
  117: i32 field117;
  118: i32 field118;
  119: i32 field119;
  120: i32 field120;
  121: i32 field121;
  122: i32 field122;
  123: i32 field123;
  124: i32 field124;
  125: i32 field125;
  126: i32 field126;
  127: i32 field127;
  128: i32 field128;
}

@thrift.TerseWrite
struct terse_struct_128_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
  17: i32 field17;
  18: i32 field18;
  19: i32 field19;
  20: i32 field20;
  21: i32 field21;
  22: i32 field22;
  23: i32 field23;
  24: i32 field24;
  25: i32 field25;
  26: i32 field26;
  27: i32 field27;
  28: i32 field28;
  29: i32 field29;
  30: i32 field30;
  31: i32 field31;
  32: i32 field32;
  33: i32 field33;
  34: i32 field34;
  35: i32 field35;
  36: i32 field36;
  37: i32 field37;
  38: i32 field38;
  39: i32 field39;
  40: i32 field40;
  41: i32 field41;
  42: i32 field42;
  43: i32 field43;
  44: i32 field44;
  45: i32 field45;
  46: i32 field46;
  47: i32 field47;
  48: i32 field48;
  49: i32 field49;
  50: i32 field50;
  51: i32 field51;
  52: i32 field52;
  53: i32 field53;
  54: i32 field54;
  55: i32 field55;
  56: i32 field56;
  57: i32 field57;
  58: i32 field58;
  59: i32 field59;
  60: i32 field60;
  61: i32 field61;
  62: i32 field62;
  63: i32 field63;
  64: i32 field64;
  65: i32 field65;
  66: i32 field66;
  67: i32 field67;
  68: i32 field68;
  69: i32 field69;
  70: i32 field70;
  71: i32 field71;
  72: i32 field72;
  73: i32 field73;
  74: i32 field74;
  75: i32 field75;
  76: i32 field76;
  77: i32 field77;
  78: i32 field78;
  79: i32 field79;
  80: i32 field80;
  81: i32 field81;
  82: i32 field82;
  83: i32 field83;
  84: i32 field84;
  85: i32 field85;
  86: i32 field86;
  87: i32 field87;
  88: i32 field88;
  89: i32 field89;
  90: i32 field90;
  91: i32 field91;
  92: i32 field92;
  93: i32 field93;
  94: i32 field94;
  95: i32 field95;
  96: i32 field96;
  97: i32 field97;
  98: i32 field98;
  99: i32 field99;
  100: i32 field100;
  101: i32 field101;
  102: i32 field102;
  103: i32 field103;
  104: i32 field104;
  105: i32 field105;
  106: i32 field106;
  107: i32 field107;
  108: i32 field108;
  109: i32 field109;
  110: i32 field110;
  111: i32 field111;
  112: i32 field112;
  113: i32 field113;
  114: i32 field114;
  115: i32 field115;
  116: i32 field116;
  117: i32 field117;
  118: i32 field118;
  119: i32 field119;
  120: i32 field120;
  121: i32 field121;
  122: i32 field122;
  123: i32 field123;
  124: i32 field124;
  125: i32 field125;
  126: i32 field126;
  127: i32 field127;
  128: i32 field128;
}

struct struct_256_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
  17: i32 field17;
  18: i32 field18;
  19: i32 field19;
  20: i32 field20;
  21: i32 field21;
  22: i32 field22;
  23: i32 field23;
  24: i32 field24;
  25: i32 field25;
  26: i32 field26;
  27: i32 field27;
  28: i32 field28;
  29: i32 field29;
  30: i32 field30;
  31: i32 field31;
  32: i32 field32;
  33: i32 field33;
  34: i32 field34;
  35: i32 field35;
  36: i32 field36;
  37: i32 field37;
  38: i32 field38;
  39: i32 field39;
  40: i32 field40;
  41: i32 field41;
  42: i32 field42;
  43: i32 field43;
  44: i32 field44;
  45: i32 field45;
  46: i32 field46;
  47: i32 field47;
  48: i32 field48;
  49: i32 field49;
  50: i32 field50;
  51: i32 field51;
  52: i32 field52;
  53: i32 field53;
  54: i32 field54;
  55: i32 field55;
  56: i32 field56;
  57: i32 field57;
  58: i32 field58;
  59: i32 field59;
  60: i32 field60;
  61: i32 field61;
  62: i32 field62;
  63: i32 field63;
  64: i32 field64;
  65: i32 field65;
  66: i32 field66;
  67: i32 field67;
  68: i32 field68;
  69: i32 field69;
  70: i32 field70;
  71: i32 field71;
  72: i32 field72;
  73: i32 field73;
  74: i32 field74;
  75: i32 field75;
  76: i32 field76;
  77: i32 field77;
  78: i32 field78;
  79: i32 field79;
  80: i32 field80;
  81: i32 field81;
  82: i32 field82;
  83: i32 field83;
  84: i32 field84;
  85: i32 field85;
  86: i32 field86;
  87: i32 field87;
  88: i32 field88;
  89: i32 field89;
  90: i32 field90;
  91: i32 field91;
  92: i32 field92;
  93: i32 field93;
  94: i32 field94;
  95: i32 field95;
  96: i32 field96;
  97: i32 field97;
  98: i32 field98;
  99: i32 field99;
  100: i32 field100;
  101: i32 field101;
  102: i32 field102;
  103: i32 field103;
  104: i32 field104;
  105: i32 field105;
  106: i32 field106;
  107: i32 field107;
  108: i32 field108;
  109: i32 field109;
  110: i32 field110;
  111: i32 field111;
  112: i32 field112;
  113: i32 field113;
  114: i32 field114;
  115: i32 field115;
  116: i32 field116;
  117: i32 field117;
  118: i32 field118;
  119: i32 field119;
  120: i32 field120;
  121: i32 field121;
  122: i32 field122;
  123: i32 field123;
  124: i32 field124;
  125: i32 field125;
  126: i32 field126;
  127: i32 field127;
  128: i32 field128;
  129: i32 field129;
  130: i32 field130;
  131: i32 field131;
  132: i32 field132;
  133: i32 field133;
  134: i32 field134;
  135: i32 field135;
  136: i32 field136;
  137: i32 field137;
  138: i32 field138;
  139: i32 field139;
  140: i32 field140;
  141: i32 field141;
  142: i32 field142;
  143: i32 field143;
  144: i32 field144;
  145: i32 field145;
  146: i32 field146;
  147: i32 field147;
  148: i32 field148;
  149: i32 field149;
  150: i32 field150;
  151: i32 field151;
  152: i32 field152;
  153: i32 field153;
  154: i32 field154;
  155: i32 field155;
  156: i32 field156;
  157: i32 field157;
  158: i32 field158;
  159: i32 field159;
  160: i32 field160;
  161: i32 field161;
  162: i32 field162;
  163: i32 field163;
  164: i32 field164;
  165: i32 field165;
  166: i32 field166;
  167: i32 field167;
  168: i32 field168;
  169: i32 field169;
  170: i32 field170;
  171: i32 field171;
  172: i32 field172;
  173: i32 field173;
  174: i32 field174;
  175: i32 field175;
  176: i32 field176;
  177: i32 field177;
  178: i32 field178;
  179: i32 field179;
  180: i32 field180;
  181: i32 field181;
  182: i32 field182;
  183: i32 field183;
  184: i32 field184;
  185: i32 field185;
  186: i32 field186;
  187: i32 field187;
  188: i32 field188;
  189: i32 field189;
  190: i32 field190;
  191: i32 field191;
  192: i32 field192;
  193: i32 field193;
  194: i32 field194;
  195: i32 field195;
  196: i32 field196;
  197: i32 field197;
  198: i32 field198;
  199: i32 field199;
  200: i32 field200;
  201: i32 field201;
  202: i32 field202;
  203: i32 field203;
  204: i32 field204;
  205: i32 field205;
  206: i32 field206;
  207: i32 field207;
  208: i32 field208;
  209: i32 field209;
  210: i32 field210;
  211: i32 field211;
  212: i32 field212;
  213: i32 field213;
  214: i32 field214;
  215: i32 field215;
  216: i32 field216;
  217: i32 field217;
  218: i32 field218;
  219: i32 field219;
  220: i32 field220;
  221: i32 field221;
  222: i32 field222;
  223: i32 field223;
  224: i32 field224;
  225: i32 field225;
  226: i32 field226;
  227: i32 field227;
  228: i32 field228;
  229: i32 field229;
  230: i32 field230;
  231: i32 field231;
  232: i32 field232;
  233: i32 field233;
  234: i32 field234;
  235: i32 field235;
  236: i32 field236;
  237: i32 field237;
  238: i32 field238;
  239: i32 field239;
  240: i32 field240;
  241: i32 field241;
  242: i32 field242;
  243: i32 field243;
  244: i32 field244;
  245: i32 field245;
  246: i32 field246;
  247: i32 field247;
  248: i32 field248;
  249: i32 field249;
  250: i32 field250;
  251: i32 field251;
  252: i32 field252;
  253: i32 field253;
  254: i32 field254;
  255: i32 field255;
  256: i32 field256;
}

@thrift.TerseWrite
struct terse_struct_256_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
  17: i32 field17;
  18: i32 field18;
  19: i32 field19;
  20: i32 field20;
  21: i32 field21;
  22: i32 field22;
  23: i32 field23;
  24: i32 field24;
  25: i32 field25;
  26: i32 field26;
  27: i32 field27;
  28: i32 field28;
  29: i32 field29;
  30: i32 field30;
  31: i32 field31;
  32: i32 field32;
  33: i32 field33;
  34: i32 field34;
  35: i32 field35;
  36: i32 field36;
  37: i32 field37;
  38: i32 field38;
  39: i32 field39;
  40: i32 field40;
  41: i32 field41;
  42: i32 field42;
  43: i32 field43;
  44: i32 field44;
  45: i32 field45;
  46: i32 field46;
  47: i32 field47;
  48: i32 field48;
  49: i32 field49;
  50: i32 field50;
  51: i32 field51;
  52: i32 field52;
  53: i32 field53;
  54: i32 field54;
  55: i32 field55;
  56: i32 field56;
  57: i32 field57;
  58: i32 field58;
  59: i32 field59;
  60: i32 field60;
  61: i32 field61;
  62: i32 field62;
  63: i32 field63;
  64: i32 field64;
  65: i32 field65;
  66: i32 field66;
  67: i32 field67;
  68: i32 field68;
  69: i32 field69;
  70: i32 field70;
  71: i32 field71;
  72: i32 field72;
  73: i32 field73;
  74: i32 field74;
  75: i32 field75;
  76: i32 field76;
  77: i32 field77;
  78: i32 field78;
  79: i32 field79;
  80: i32 field80;
  81: i32 field81;
  82: i32 field82;
  83: i32 field83;
  84: i32 field84;
  85: i32 field85;
  86: i32 field86;
  87: i32 field87;
  88: i32 field88;
  89: i32 field89;
  90: i32 field90;
  91: i32 field91;
  92: i32 field92;
  93: i32 field93;
  94: i32 field94;
  95: i32 field95;
  96: i32 field96;
  97: i32 field97;
  98: i32 field98;
  99: i32 field99;
  100: i32 field100;
  101: i32 field101;
  102: i32 field102;
  103: i32 field103;
  104: i32 field104;
  105: i32 field105;
  106: i32 field106;
  107: i32 field107;
  108: i32 field108;
  109: i32 field109;
  110: i32 field110;
  111: i32 field111;
  112: i32 field112;
  113: i32 field113;
  114: i32 field114;
  115: i32 field115;
  116: i32 field116;
  117: i32 field117;
  118: i32 field118;
  119: i32 field119;
  120: i32 field120;
  121: i32 field121;
  122: i32 field122;
  123: i32 field123;
  124: i32 field124;
  125: i32 field125;
  126: i32 field126;
  127: i32 field127;
  128: i32 field128;
  129: i32 field129;
  130: i32 field130;
  131: i32 field131;
  132: i32 field132;
  133: i32 field133;
  134: i32 field134;
  135: i32 field135;
  136: i32 field136;
  137: i32 field137;
  138: i32 field138;
  139: i32 field139;
  140: i32 field140;
  141: i32 field141;
  142: i32 field142;
  143: i32 field143;
  144: i32 field144;
  145: i32 field145;
  146: i32 field146;
  147: i32 field147;
  148: i32 field148;
  149: i32 field149;
  150: i32 field150;
  151: i32 field151;
  152: i32 field152;
  153: i32 field153;
  154: i32 field154;
  155: i32 field155;
  156: i32 field156;
  157: i32 field157;
  158: i32 field158;
  159: i32 field159;
  160: i32 field160;
  161: i32 field161;
  162: i32 field162;
  163: i32 field163;
  164: i32 field164;
  165: i32 field165;
  166: i32 field166;
  167: i32 field167;
  168: i32 field168;
  169: i32 field169;
  170: i32 field170;
  171: i32 field171;
  172: i32 field172;
  173: i32 field173;
  174: i32 field174;
  175: i32 field175;
  176: i32 field176;
  177: i32 field177;
  178: i32 field178;
  179: i32 field179;
  180: i32 field180;
  181: i32 field181;
  182: i32 field182;
  183: i32 field183;
  184: i32 field184;
  185: i32 field185;
  186: i32 field186;
  187: i32 field187;
  188: i32 field188;
  189: i32 field189;
  190: i32 field190;
  191: i32 field191;
  192: i32 field192;
  193: i32 field193;
  194: i32 field194;
  195: i32 field195;
  196: i32 field196;
  197: i32 field197;
  198: i32 field198;
  199: i32 field199;
  200: i32 field200;
  201: i32 field201;
  202: i32 field202;
  203: i32 field203;
  204: i32 field204;
  205: i32 field205;
  206: i32 field206;
  207: i32 field207;
  208: i32 field208;
  209: i32 field209;
  210: i32 field210;
  211: i32 field211;
  212: i32 field212;
  213: i32 field213;
  214: i32 field214;
  215: i32 field215;
  216: i32 field216;
  217: i32 field217;
  218: i32 field218;
  219: i32 field219;
  220: i32 field220;
  221: i32 field221;
  222: i32 field222;
  223: i32 field223;
  224: i32 field224;
  225: i32 field225;
  226: i32 field226;
  227: i32 field227;
  228: i32 field228;
  229: i32 field229;
  230: i32 field230;
  231: i32 field231;
  232: i32 field232;
  233: i32 field233;
  234: i32 field234;
  235: i32 field235;
  236: i32 field236;
  237: i32 field237;
  238: i32 field238;
  239: i32 field239;
  240: i32 field240;
  241: i32 field241;
  242: i32 field242;
  243: i32 field243;
  244: i32 field244;
  245: i32 field245;
  246: i32 field246;
  247: i32 field247;
  248: i32 field248;
  249: i32 field249;
  250: i32 field250;
  251: i32 field251;
  252: i32 field252;
  253: i32 field253;
  254: i32 field254;
  255: i32 field255;
  256: i32 field256;
}

struct struct_512_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
  17: i32 field17;
  18: i32 field18;
  19: i32 field19;
  20: i32 field20;
  21: i32 field21;
  22: i32 field22;
  23: i32 field23;
  24: i32 field24;
  25: i32 field25;
  26: i32 field26;
  27: i32 field27;
  28: i32 field28;
  29: i32 field29;
  30: i32 field30;
  31: i32 field31;
  32: i32 field32;
  33: i32 field33;
  34: i32 field34;
  35: i32 field35;
  36: i32 field36;
  37: i32 field37;
  38: i32 field38;
  39: i32 field39;
  40: i32 field40;
  41: i32 field41;
  42: i32 field42;
  43: i32 field43;
  44: i32 field44;
  45: i32 field45;
  46: i32 field46;
  47: i32 field47;
  48: i32 field48;
  49: i32 field49;
  50: i32 field50;
  51: i32 field51;
  52: i32 field52;
  53: i32 field53;
  54: i32 field54;
  55: i32 field55;
  56: i32 field56;
  57: i32 field57;
  58: i32 field58;
  59: i32 field59;
  60: i32 field60;
  61: i32 field61;
  62: i32 field62;
  63: i32 field63;
  64: i32 field64;
  65: i32 field65;
  66: i32 field66;
  67: i32 field67;
  68: i32 field68;
  69: i32 field69;
  70: i32 field70;
  71: i32 field71;
  72: i32 field72;
  73: i32 field73;
  74: i32 field74;
  75: i32 field75;
  76: i32 field76;
  77: i32 field77;
  78: i32 field78;
  79: i32 field79;
  80: i32 field80;
  81: i32 field81;
  82: i32 field82;
  83: i32 field83;
  84: i32 field84;
  85: i32 field85;
  86: i32 field86;
  87: i32 field87;
  88: i32 field88;
  89: i32 field89;
  90: i32 field90;
  91: i32 field91;
  92: i32 field92;
  93: i32 field93;
  94: i32 field94;
  95: i32 field95;
  96: i32 field96;
  97: i32 field97;
  98: i32 field98;
  99: i32 field99;
  100: i32 field100;
  101: i32 field101;
  102: i32 field102;
  103: i32 field103;
  104: i32 field104;
  105: i32 field105;
  106: i32 field106;
  107: i32 field107;
  108: i32 field108;
  109: i32 field109;
  110: i32 field110;
  111: i32 field111;
  112: i32 field112;
  113: i32 field113;
  114: i32 field114;
  115: i32 field115;
  116: i32 field116;
  117: i32 field117;
  118: i32 field118;
  119: i32 field119;
  120: i32 field120;
  121: i32 field121;
  122: i32 field122;
  123: i32 field123;
  124: i32 field124;
  125: i32 field125;
  126: i32 field126;
  127: i32 field127;
  128: i32 field128;
  129: i32 field129;
  130: i32 field130;
  131: i32 field131;
  132: i32 field132;
  133: i32 field133;
  134: i32 field134;
  135: i32 field135;
  136: i32 field136;
  137: i32 field137;
  138: i32 field138;
  139: i32 field139;
  140: i32 field140;
  141: i32 field141;
  142: i32 field142;
  143: i32 field143;
  144: i32 field144;
  145: i32 field145;
  146: i32 field146;
  147: i32 field147;
  148: i32 field148;
  149: i32 field149;
  150: i32 field150;
  151: i32 field151;
  152: i32 field152;
  153: i32 field153;
  154: i32 field154;
  155: i32 field155;
  156: i32 field156;
  157: i32 field157;
  158: i32 field158;
  159: i32 field159;
  160: i32 field160;
  161: i32 field161;
  162: i32 field162;
  163: i32 field163;
  164: i32 field164;
  165: i32 field165;
  166: i32 field166;
  167: i32 field167;
  168: i32 field168;
  169: i32 field169;
  170: i32 field170;
  171: i32 field171;
  172: i32 field172;
  173: i32 field173;
  174: i32 field174;
  175: i32 field175;
  176: i32 field176;
  177: i32 field177;
  178: i32 field178;
  179: i32 field179;
  180: i32 field180;
  181: i32 field181;
  182: i32 field182;
  183: i32 field183;
  184: i32 field184;
  185: i32 field185;
  186: i32 field186;
  187: i32 field187;
  188: i32 field188;
  189: i32 field189;
  190: i32 field190;
  191: i32 field191;
  192: i32 field192;
  193: i32 field193;
  194: i32 field194;
  195: i32 field195;
  196: i32 field196;
  197: i32 field197;
  198: i32 field198;
  199: i32 field199;
  200: i32 field200;
  201: i32 field201;
  202: i32 field202;
  203: i32 field203;
  204: i32 field204;
  205: i32 field205;
  206: i32 field206;
  207: i32 field207;
  208: i32 field208;
  209: i32 field209;
  210: i32 field210;
  211: i32 field211;
  212: i32 field212;
  213: i32 field213;
  214: i32 field214;
  215: i32 field215;
  216: i32 field216;
  217: i32 field217;
  218: i32 field218;
  219: i32 field219;
  220: i32 field220;
  221: i32 field221;
  222: i32 field222;
  223: i32 field223;
  224: i32 field224;
  225: i32 field225;
  226: i32 field226;
  227: i32 field227;
  228: i32 field228;
  229: i32 field229;
  230: i32 field230;
  231: i32 field231;
  232: i32 field232;
  233: i32 field233;
  234: i32 field234;
  235: i32 field235;
  236: i32 field236;
  237: i32 field237;
  238: i32 field238;
  239: i32 field239;
  240: i32 field240;
  241: i32 field241;
  242: i32 field242;
  243: i32 field243;
  244: i32 field244;
  245: i32 field245;
  246: i32 field246;
  247: i32 field247;
  248: i32 field248;
  249: i32 field249;
  250: i32 field250;
  251: i32 field251;
  252: i32 field252;
  253: i32 field253;
  254: i32 field254;
  255: i32 field255;
  256: i32 field256;
  257: i32 field257;
  258: i32 field258;
  259: i32 field259;
  260: i32 field260;
  261: i32 field261;
  262: i32 field262;
  263: i32 field263;
  264: i32 field264;
  265: i32 field265;
  266: i32 field266;
  267: i32 field267;
  268: i32 field268;
  269: i32 field269;
  270: i32 field270;
  271: i32 field271;
  272: i32 field272;
  273: i32 field273;
  274: i32 field274;
  275: i32 field275;
  276: i32 field276;
  277: i32 field277;
  278: i32 field278;
  279: i32 field279;
  280: i32 field280;
  281: i32 field281;
  282: i32 field282;
  283: i32 field283;
  284: i32 field284;
  285: i32 field285;
  286: i32 field286;
  287: i32 field287;
  288: i32 field288;
  289: i32 field289;
  290: i32 field290;
  291: i32 field291;
  292: i32 field292;
  293: i32 field293;
  294: i32 field294;
  295: i32 field295;
  296: i32 field296;
  297: i32 field297;
  298: i32 field298;
  299: i32 field299;
  300: i32 field300;
  301: i32 field301;
  302: i32 field302;
  303: i32 field303;
  304: i32 field304;
  305: i32 field305;
  306: i32 field306;
  307: i32 field307;
  308: i32 field308;
  309: i32 field309;
  310: i32 field310;
  311: i32 field311;
  312: i32 field312;
  313: i32 field313;
  314: i32 field314;
  315: i32 field315;
  316: i32 field316;
  317: i32 field317;
  318: i32 field318;
  319: i32 field319;
  320: i32 field320;
  321: i32 field321;
  322: i32 field322;
  323: i32 field323;
  324: i32 field324;
  325: i32 field325;
  326: i32 field326;
  327: i32 field327;
  328: i32 field328;
  329: i32 field329;
  330: i32 field330;
  331: i32 field331;
  332: i32 field332;
  333: i32 field333;
  334: i32 field334;
  335: i32 field335;
  336: i32 field336;
  337: i32 field337;
  338: i32 field338;
  339: i32 field339;
  340: i32 field340;
  341: i32 field341;
  342: i32 field342;
  343: i32 field343;
  344: i32 field344;
  345: i32 field345;
  346: i32 field346;
  347: i32 field347;
  348: i32 field348;
  349: i32 field349;
  350: i32 field350;
  351: i32 field351;
  352: i32 field352;
  353: i32 field353;
  354: i32 field354;
  355: i32 field355;
  356: i32 field356;
  357: i32 field357;
  358: i32 field358;
  359: i32 field359;
  360: i32 field360;
  361: i32 field361;
  362: i32 field362;
  363: i32 field363;
  364: i32 field364;
  365: i32 field365;
  366: i32 field366;
  367: i32 field367;
  368: i32 field368;
  369: i32 field369;
  370: i32 field370;
  371: i32 field371;
  372: i32 field372;
  373: i32 field373;
  374: i32 field374;
  375: i32 field375;
  376: i32 field376;
  377: i32 field377;
  378: i32 field378;
  379: i32 field379;
  380: i32 field380;
  381: i32 field381;
  382: i32 field382;
  383: i32 field383;
  384: i32 field384;
  385: i32 field385;
  386: i32 field386;
  387: i32 field387;
  388: i32 field388;
  389: i32 field389;
  390: i32 field390;
  391: i32 field391;
  392: i32 field392;
  393: i32 field393;
  394: i32 field394;
  395: i32 field395;
  396: i32 field396;
  397: i32 field397;
  398: i32 field398;
  399: i32 field399;
  400: i32 field400;
  401: i32 field401;
  402: i32 field402;
  403: i32 field403;
  404: i32 field404;
  405: i32 field405;
  406: i32 field406;
  407: i32 field407;
  408: i32 field408;
  409: i32 field409;
  410: i32 field410;
  411: i32 field411;
  412: i32 field412;
  413: i32 field413;
  414: i32 field414;
  415: i32 field415;
  416: i32 field416;
  417: i32 field417;
  418: i32 field418;
  419: i32 field419;
  420: i32 field420;
  421: i32 field421;
  422: i32 field422;
  423: i32 field423;
  424: i32 field424;
  425: i32 field425;
  426: i32 field426;
  427: i32 field427;
  428: i32 field428;
  429: i32 field429;
  430: i32 field430;
  431: i32 field431;
  432: i32 field432;
  433: i32 field433;
  434: i32 field434;
  435: i32 field435;
  436: i32 field436;
  437: i32 field437;
  438: i32 field438;
  439: i32 field439;
  440: i32 field440;
  441: i32 field441;
  442: i32 field442;
  443: i32 field443;
  444: i32 field444;
  445: i32 field445;
  446: i32 field446;
  447: i32 field447;
  448: i32 field448;
  449: i32 field449;
  450: i32 field450;
  451: i32 field451;
  452: i32 field452;
  453: i32 field453;
  454: i32 field454;
  455: i32 field455;
  456: i32 field456;
  457: i32 field457;
  458: i32 field458;
  459: i32 field459;
  460: i32 field460;
  461: i32 field461;
  462: i32 field462;
  463: i32 field463;
  464: i32 field464;
  465: i32 field465;
  466: i32 field466;
  467: i32 field467;
  468: i32 field468;
  469: i32 field469;
  470: i32 field470;
  471: i32 field471;
  472: i32 field472;
  473: i32 field473;
  474: i32 field474;
  475: i32 field475;
  476: i32 field476;
  477: i32 field477;
  478: i32 field478;
  479: i32 field479;
  480: i32 field480;
  481: i32 field481;
  482: i32 field482;
  483: i32 field483;
  484: i32 field484;
  485: i32 field485;
  486: i32 field486;
  487: i32 field487;
  488: i32 field488;
  489: i32 field489;
  490: i32 field490;
  491: i32 field491;
  492: i32 field492;
  493: i32 field493;
  494: i32 field494;
  495: i32 field495;
  496: i32 field496;
  497: i32 field497;
  498: i32 field498;
  499: i32 field499;
  500: i32 field500;
  501: i32 field501;
  502: i32 field502;
  503: i32 field503;
  504: i32 field504;
  505: i32 field505;
  506: i32 field506;
  507: i32 field507;
  508: i32 field508;
  509: i32 field509;
  510: i32 field510;
  511: i32 field511;
  512: i32 field512;
}

@thrift.TerseWrite
struct terse_struct_512_internal {
  1: i32 field1;
  2: i32 field2;
  3: i32 field3;
  4: i32 field4;
  5: i32 field5;
  6: i32 field6;
  7: i32 field7;
  8: i32 field8;
  9: i32 field9;
  10: i32 field10;
  11: i32 field11;
  12: i32 field12;
  13: i32 field13;
  14: i32 field14;
  15: i32 field15;
  16: i32 field16;
  17: i32 field17;
  18: i32 field18;
  19: i32 field19;
  20: i32 field20;
  21: i32 field21;
  22: i32 field22;
  23: i32 field23;
  24: i32 field24;
  25: i32 field25;
  26: i32 field26;
  27: i32 field27;
  28: i32 field28;
  29: i32 field29;
  30: i32 field30;
  31: i32 field31;
  32: i32 field32;
  33: i32 field33;
  34: i32 field34;
  35: i32 field35;
  36: i32 field36;
  37: i32 field37;
  38: i32 field38;
  39: i32 field39;
  40: i32 field40;
  41: i32 field41;
  42: i32 field42;
  43: i32 field43;
  44: i32 field44;
  45: i32 field45;
  46: i32 field46;
  47: i32 field47;
  48: i32 field48;
  49: i32 field49;
  50: i32 field50;
  51: i32 field51;
  52: i32 field52;
  53: i32 field53;
  54: i32 field54;
  55: i32 field55;
  56: i32 field56;
  57: i32 field57;
  58: i32 field58;
  59: i32 field59;
  60: i32 field60;
  61: i32 field61;
  62: i32 field62;
  63: i32 field63;
  64: i32 field64;
  65: i32 field65;
  66: i32 field66;
  67: i32 field67;
  68: i32 field68;
  69: i32 field69;
  70: i32 field70;
  71: i32 field71;
  72: i32 field72;
  73: i32 field73;
  74: i32 field74;
  75: i32 field75;
  76: i32 field76;
  77: i32 field77;
  78: i32 field78;
  79: i32 field79;
  80: i32 field80;
  81: i32 field81;
  82: i32 field82;
  83: i32 field83;
  84: i32 field84;
  85: i32 field85;
  86: i32 field86;
  87: i32 field87;
  88: i32 field88;
  89: i32 field89;
  90: i32 field90;
  91: i32 field91;
  92: i32 field92;
  93: i32 field93;
  94: i32 field94;
  95: i32 field95;
  96: i32 field96;
  97: i32 field97;
  98: i32 field98;
  99: i32 field99;
  100: i32 field100;
  101: i32 field101;
  102: i32 field102;
  103: i32 field103;
  104: i32 field104;
  105: i32 field105;
  106: i32 field106;
  107: i32 field107;
  108: i32 field108;
  109: i32 field109;
  110: i32 field110;
  111: i32 field111;
  112: i32 field112;
  113: i32 field113;
  114: i32 field114;
  115: i32 field115;
  116: i32 field116;
  117: i32 field117;
  118: i32 field118;
  119: i32 field119;
  120: i32 field120;
  121: i32 field121;
  122: i32 field122;
  123: i32 field123;
  124: i32 field124;
  125: i32 field125;
  126: i32 field126;
  127: i32 field127;
  128: i32 field128;
  129: i32 field129;
  130: i32 field130;
  131: i32 field131;
  132: i32 field132;
  133: i32 field133;
  134: i32 field134;
  135: i32 field135;
  136: i32 field136;
  137: i32 field137;
  138: i32 field138;
  139: i32 field139;
  140: i32 field140;
  141: i32 field141;
  142: i32 field142;
  143: i32 field143;
  144: i32 field144;
  145: i32 field145;
  146: i32 field146;
  147: i32 field147;
  148: i32 field148;
  149: i32 field149;
  150: i32 field150;
  151: i32 field151;
  152: i32 field152;
  153: i32 field153;
  154: i32 field154;
  155: i32 field155;
  156: i32 field156;
  157: i32 field157;
  158: i32 field158;
  159: i32 field159;
  160: i32 field160;
  161: i32 field161;
  162: i32 field162;
  163: i32 field163;
  164: i32 field164;
  165: i32 field165;
  166: i32 field166;
  167: i32 field167;
  168: i32 field168;
  169: i32 field169;
  170: i32 field170;
  171: i32 field171;
  172: i32 field172;
  173: i32 field173;
  174: i32 field174;
  175: i32 field175;
  176: i32 field176;
  177: i32 field177;
  178: i32 field178;
  179: i32 field179;
  180: i32 field180;
  181: i32 field181;
  182: i32 field182;
  183: i32 field183;
  184: i32 field184;
  185: i32 field185;
  186: i32 field186;
  187: i32 field187;
  188: i32 field188;
  189: i32 field189;
  190: i32 field190;
  191: i32 field191;
  192: i32 field192;
  193: i32 field193;
  194: i32 field194;
  195: i32 field195;
  196: i32 field196;
  197: i32 field197;
  198: i32 field198;
  199: i32 field199;
  200: i32 field200;
  201: i32 field201;
  202: i32 field202;
  203: i32 field203;
  204: i32 field204;
  205: i32 field205;
  206: i32 field206;
  207: i32 field207;
  208: i32 field208;
  209: i32 field209;
  210: i32 field210;
  211: i32 field211;
  212: i32 field212;
  213: i32 field213;
  214: i32 field214;
  215: i32 field215;
  216: i32 field216;
  217: i32 field217;
  218: i32 field218;
  219: i32 field219;
  220: i32 field220;
  221: i32 field221;
  222: i32 field222;
  223: i32 field223;
  224: i32 field224;
  225: i32 field225;
  226: i32 field226;
  227: i32 field227;
  228: i32 field228;
  229: i32 field229;
  230: i32 field230;
  231: i32 field231;
  232: i32 field232;
  233: i32 field233;
  234: i32 field234;
  235: i32 field235;
  236: i32 field236;
  237: i32 field237;
  238: i32 field238;
  239: i32 field239;
  240: i32 field240;
  241: i32 field241;
  242: i32 field242;
  243: i32 field243;
  244: i32 field244;
  245: i32 field245;
  246: i32 field246;
  247: i32 field247;
  248: i32 field248;
  249: i32 field249;
  250: i32 field250;
  251: i32 field251;
  252: i32 field252;
  253: i32 field253;
  254: i32 field254;
  255: i32 field255;
  256: i32 field256;
  257: i32 field257;
  258: i32 field258;
  259: i32 field259;
  260: i32 field260;
  261: i32 field261;
  262: i32 field262;
  263: i32 field263;
  264: i32 field264;
  265: i32 field265;
  266: i32 field266;
  267: i32 field267;
  268: i32 field268;
  269: i32 field269;
  270: i32 field270;
  271: i32 field271;
  272: i32 field272;
  273: i32 field273;
  274: i32 field274;
  275: i32 field275;
  276: i32 field276;
  277: i32 field277;
  278: i32 field278;
  279: i32 field279;
  280: i32 field280;
  281: i32 field281;
  282: i32 field282;
  283: i32 field283;
  284: i32 field284;
  285: i32 field285;
  286: i32 field286;
  287: i32 field287;
  288: i32 field288;
  289: i32 field289;
  290: i32 field290;
  291: i32 field291;
  292: i32 field292;
  293: i32 field293;
  294: i32 field294;
  295: i32 field295;
  296: i32 field296;
  297: i32 field297;
  298: i32 field298;
  299: i32 field299;
  300: i32 field300;
  301: i32 field301;
  302: i32 field302;
  303: i32 field303;
  304: i32 field304;
  305: i32 field305;
  306: i32 field306;
  307: i32 field307;
  308: i32 field308;
  309: i32 field309;
  310: i32 field310;
  311: i32 field311;
  312: i32 field312;
  313: i32 field313;
  314: i32 field314;
  315: i32 field315;
  316: i32 field316;
  317: i32 field317;
  318: i32 field318;
  319: i32 field319;
  320: i32 field320;
  321: i32 field321;
  322: i32 field322;
  323: i32 field323;
  324: i32 field324;
  325: i32 field325;
  326: i32 field326;
  327: i32 field327;
  328: i32 field328;
  329: i32 field329;
  330: i32 field330;
  331: i32 field331;
  332: i32 field332;
  333: i32 field333;
  334: i32 field334;
  335: i32 field335;
  336: i32 field336;
  337: i32 field337;
  338: i32 field338;
  339: i32 field339;
  340: i32 field340;
  341: i32 field341;
  342: i32 field342;
  343: i32 field343;
  344: i32 field344;
  345: i32 field345;
  346: i32 field346;
  347: i32 field347;
  348: i32 field348;
  349: i32 field349;
  350: i32 field350;
  351: i32 field351;
  352: i32 field352;
  353: i32 field353;
  354: i32 field354;
  355: i32 field355;
  356: i32 field356;
  357: i32 field357;
  358: i32 field358;
  359: i32 field359;
  360: i32 field360;
  361: i32 field361;
  362: i32 field362;
  363: i32 field363;
  364: i32 field364;
  365: i32 field365;
  366: i32 field366;
  367: i32 field367;
  368: i32 field368;
  369: i32 field369;
  370: i32 field370;
  371: i32 field371;
  372: i32 field372;
  373: i32 field373;
  374: i32 field374;
  375: i32 field375;
  376: i32 field376;
  377: i32 field377;
  378: i32 field378;
  379: i32 field379;
  380: i32 field380;
  381: i32 field381;
  382: i32 field382;
  383: i32 field383;
  384: i32 field384;
  385: i32 field385;
  386: i32 field386;
  387: i32 field387;
  388: i32 field388;
  389: i32 field389;
  390: i32 field390;
  391: i32 field391;
  392: i32 field392;
  393: i32 field393;
  394: i32 field394;
  395: i32 field395;
  396: i32 field396;
  397: i32 field397;
  398: i32 field398;
  399: i32 field399;
  400: i32 field400;
  401: i32 field401;
  402: i32 field402;
  403: i32 field403;
  404: i32 field404;
  405: i32 field405;
  406: i32 field406;
  407: i32 field407;
  408: i32 field408;
  409: i32 field409;
  410: i32 field410;
  411: i32 field411;
  412: i32 field412;
  413: i32 field413;
  414: i32 field414;
  415: i32 field415;
  416: i32 field416;
  417: i32 field417;
  418: i32 field418;
  419: i32 field419;
  420: i32 field420;
  421: i32 field421;
  422: i32 field422;
  423: i32 field423;
  424: i32 field424;
  425: i32 field425;
  426: i32 field426;
  427: i32 field427;
  428: i32 field428;
  429: i32 field429;
  430: i32 field430;
  431: i32 field431;
  432: i32 field432;
  433: i32 field433;
  434: i32 field434;
  435: i32 field435;
  436: i32 field436;
  437: i32 field437;
  438: i32 field438;
  439: i32 field439;
  440: i32 field440;
  441: i32 field441;
  442: i32 field442;
  443: i32 field443;
  444: i32 field444;
  445: i32 field445;
  446: i32 field446;
  447: i32 field447;
  448: i32 field448;
  449: i32 field449;
  450: i32 field450;
  451: i32 field451;
  452: i32 field452;
  453: i32 field453;
  454: i32 field454;
  455: i32 field455;
  456: i32 field456;
  457: i32 field457;
  458: i32 field458;
  459: i32 field459;
  460: i32 field460;
  461: i32 field461;
  462: i32 field462;
  463: i32 field463;
  464: i32 field464;
  465: i32 field465;
  466: i32 field466;
  467: i32 field467;
  468: i32 field468;
  469: i32 field469;
  470: i32 field470;
  471: i32 field471;
  472: i32 field472;
  473: i32 field473;
  474: i32 field474;
  475: i32 field475;
  476: i32 field476;
  477: i32 field477;
  478: i32 field478;
  479: i32 field479;
  480: i32 field480;
  481: i32 field481;
  482: i32 field482;
  483: i32 field483;
  484: i32 field484;
  485: i32 field485;
  486: i32 field486;
  487: i32 field487;
  488: i32 field488;
  489: i32 field489;
  490: i32 field490;
  491: i32 field491;
  492: i32 field492;
  493: i32 field493;
  494: i32 field494;
  495: i32 field495;
  496: i32 field496;
  497: i32 field497;
  498: i32 field498;
  499: i32 field499;
  500: i32 field500;
  501: i32 field501;
  502: i32 field502;
  503: i32 field503;
  504: i32 field504;
  505: i32 field505;
  506: i32 field506;
  507: i32 field507;
  508: i32 field508;
  509: i32 field509;
  510: i32 field510;
  511: i32 field511;
  512: i32 field512;
}
